/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface AzureLoginRequest
 */
export interface AzureLoginRequest {
    /**
     * A signed JWT
     * @type {string}
     * @memberof AzureLoginRequest
     */
    jwt?: string;
    /**
     * The resource group from the instance.
     * @type {string}
     * @memberof AzureLoginRequest
     */
    resourceGroupName?: string;
    /**
     * The fully qualified ID of the resource, includingthe resource name and resource type. Use the format, /subscriptions/{guid}/resourceGroups/{resource-group-name}/{resource-provider-namespace}/{resource-type}/{resource-name}. This value is ignored if vm_name or vmss_name is specified.
     * @type {string}
     * @memberof AzureLoginRequest
     */
    resourceId?: string;
    /**
     * The token role.
     * @type {string}
     * @memberof AzureLoginRequest
     */
    role?: string;
    /**
     * The subscription id for the instance.
     * @type {string}
     * @memberof AzureLoginRequest
     */
    subscriptionId?: string;
    /**
     * The name of the virtual machine. This value is ignored if vmss_name is specified.
     * @type {string}
     * @memberof AzureLoginRequest
     */
    vmName?: string;
    /**
     * The name of the virtual machine scale set the instance is in.
     * @type {string}
     * @memberof AzureLoginRequest
     */
    vmssName?: string;
}
/**
 * Check if a given object implements the AzureLoginRequest interface.
 */
export declare function instanceOfAzureLoginRequest(value: object): value is AzureLoginRequest;
export declare function AzureLoginRequestFromJSON(json: any): AzureLoginRequest;
export declare function AzureLoginRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): AzureLoginRequest;
export declare function AzureLoginRequestToJSON(json: any): AzureLoginRequest;
export declare function AzureLoginRequestToJSONTyped(value?: AzureLoginRequest | null, ignoreDiscriminator?: boolean): any;
