/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface GoogleCloudKmsDecryptRequest
 */
export interface GoogleCloudKmsDecryptRequest {
    /**
     * Optional data that was specified during encryption of this payload.
     * @type {string}
     * @memberof GoogleCloudKmsDecryptRequest
     */
    additionalAuthenticatedData?: string;
    /**
     * Ciphertext to decrypt as previously returned from an encrypt operation. This must be base64-encoded ciphertext as previously returned from an encrypt operation.
     * @type {string}
     * @memberof GoogleCloudKmsDecryptRequest
     */
    ciphertext?: string;
    /**
     * Integer version of the crypto key version to use for decryption. This is required for asymmetric keys. For symmetric keys, Cloud KMS will choose the correct version automatically.
     * @type {number}
     * @memberof GoogleCloudKmsDecryptRequest
     */
    keyVersion?: number;
}
/**
 * Check if a given object implements the GoogleCloudKmsDecryptRequest interface.
 */
export declare function instanceOfGoogleCloudKmsDecryptRequest(value: object): value is GoogleCloudKmsDecryptRequest;
export declare function GoogleCloudKmsDecryptRequestFromJSON(json: any): GoogleCloudKmsDecryptRequest;
export declare function GoogleCloudKmsDecryptRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): GoogleCloudKmsDecryptRequest;
export declare function GoogleCloudKmsDecryptRequestToJSON(json: any): GoogleCloudKmsDecryptRequest;
export declare function GoogleCloudKmsDecryptRequestToJSONTyped(value?: GoogleCloudKmsDecryptRequest | null, ignoreDiscriminator?: boolean): any;
