/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface KubernetesConfigureRequest
 */
export interface KubernetesConfigureRequest {
    /**
     * Disable defaulting to the local CA certificate and service account JWT when running in a Kubernetes pod.
     * @type {boolean}
     * @memberof KubernetesConfigureRequest
     */
    disableLocalCaJwt?: boolean;
    /**
     * PEM encoded CA certificate to use to verify the Kubernetes API server certificate. Defaults to the local pod's CA if found.
     * @type {string}
     * @memberof KubernetesConfigureRequest
     */
    kubernetesCaCert?: string;
    /**
     * Kubernetes API URL to connect to. Defaults to https://$KUBERNETES_SERVICE_HOST:KUBERNETES_SERVICE_PORT if those environment variables are set.
     * @type {string}
     * @memberof KubernetesConfigureRequest
     */
    kubernetesHost?: string;
    /**
     * The JSON web token of the service account used by the secret engine to manage Kubernetes credentials. Defaults to the local pod's JWT if found.
     * @type {string}
     * @memberof KubernetesConfigureRequest
     */
    serviceAccountJwt?: string;
}
/**
 * Check if a given object implements the KubernetesConfigureRequest interface.
 */
export declare function instanceOfKubernetesConfigureRequest(value: object): value is KubernetesConfigureRequest;
export declare function KubernetesConfigureRequestFromJSON(json: any): KubernetesConfigureRequest;
export declare function KubernetesConfigureRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): KubernetesConfigureRequest;
export declare function KubernetesConfigureRequestToJSON(json: any): KubernetesConfigureRequest;
export declare function KubernetesConfigureRequestToJSONTyped(value?: KubernetesConfigureRequest | null, ignoreDiscriminator?: boolean): any;
