/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface KvV2ConfigureRequest
 */
export interface KvV2ConfigureRequest {
    /**
     * If true, the backend will require the cas parameter to be set for each write
     * @type {boolean}
     * @memberof KvV2ConfigureRequest
     */
    casRequired?: boolean;
    /**
     * If set, the length of time before a version is deleted. A negative duration disables the use of delete_version_after on all keys. A zero duration clears the current setting. Accepts a Go duration format string.
     * @type {string}
     * @memberof KvV2ConfigureRequest
     */
    deleteVersionAfter?: string;
    /**
     * The number of versions to keep for each key. Defaults to 10
     * @type {number}
     * @memberof KvV2ConfigureRequest
     */
    maxVersions?: number;
}
/**
 * Check if a given object implements the KvV2ConfigureRequest interface.
 */
export declare function instanceOfKvV2ConfigureRequest(value: object): value is KvV2ConfigureRequest;
export declare function KvV2ConfigureRequestFromJSON(json: any): KvV2ConfigureRequest;
export declare function KvV2ConfigureRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): KvV2ConfigureRequest;
export declare function KvV2ConfigureRequestToJSON(json: any): KvV2ConfigureRequest;
export declare function KvV2ConfigureRequestToJSONTyped(value?: KvV2ConfigureRequest | null, ignoreDiscriminator?: boolean): any;
