/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface KvV2WriteRequest
 */
export interface KvV2WriteRequest {
    /**
     * The contents of the data map will be stored and returned on read.
     * @type {object}
     * @memberof KvV2WriteRequest
     */
    data?: object;
    /**
     * Options for writing a KV entry. Set the "cas" value to use a Check-And-Set operation. If not set the write will be allowed. If set to 0 a write will only be allowed if the key doesn’t exist. If the index is non-zero the write will only be allowed if the key’s current version matches the version specified in the cas parameter.
     * @type {object}
     * @memberof KvV2WriteRequest
     */
    options?: object;
    /**
     * If provided during a read, the value at the version number will be returned
     * @type {number}
     * @memberof KvV2WriteRequest
     */
    version?: number;
}
/**
 * Check if a given object implements the KvV2WriteRequest interface.
 */
export declare function instanceOfKvV2WriteRequest(value: object): value is KvV2WriteRequest;
export declare function KvV2WriteRequestFromJSON(json: any): KvV2WriteRequest;
export declare function KvV2WriteRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): KvV2WriteRequest;
export declare function KvV2WriteRequestToJSON(json: any): KvV2WriteRequest;
export declare function KvV2WriteRequestToJSONTyped(value?: KvV2WriteRequest | null, ignoreDiscriminator?: boolean): any;
