/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface MfaUpdateDuoMethodRequest
 */
export interface MfaUpdateDuoMethodRequest {
    /**
     * API host name for Duo.
     * @type {string}
     * @memberof MfaUpdateDuoMethodRequest
     */
    apiHostname?: string;
    /**
     * Integration key for Duo.
     * @type {string}
     * @memberof MfaUpdateDuoMethodRequest
     */
    integrationKey?: string;
    /**
     * The unique name identifier for this MFA method.
     * @type {string}
     * @memberof MfaUpdateDuoMethodRequest
     */
    methodName?: string;
    /**
     * Push information for Duo.
     * @type {string}
     * @memberof MfaUpdateDuoMethodRequest
     */
    pushInfo?: string;
    /**
     * Secret key for Duo.
     * @type {string}
     * @memberof MfaUpdateDuoMethodRequest
     */
    secretKey?: string;
    /**
     * If true, the user is reminded to use the passcode upon MFA validation. This option does not enforce using the passcode. Defaults to false.
     * @type {boolean}
     * @memberof MfaUpdateDuoMethodRequest
     */
    usePasscode?: boolean;
    /**
     * A template string for mapping Identity names to MFA method names. Values to subtitute should be placed in {{}}. For example, "{{alias.name}}@example.com". Currently-supported mappings: alias.name: The name returned by the mount configured via the mount_accessor parameter If blank, the Alias's name field will be used as-is.
     * @type {string}
     * @memberof MfaUpdateDuoMethodRequest
     */
    usernameFormat?: string;
}
/**
 * Check if a given object implements the MfaUpdateDuoMethodRequest interface.
 */
export declare function instanceOfMfaUpdateDuoMethodRequest(value: object): value is MfaUpdateDuoMethodRequest;
export declare function MfaUpdateDuoMethodRequestFromJSON(json: any): MfaUpdateDuoMethodRequest;
export declare function MfaUpdateDuoMethodRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): MfaUpdateDuoMethodRequest;
export declare function MfaUpdateDuoMethodRequestToJSON(json: any): MfaUpdateDuoMethodRequest;
export declare function MfaUpdateDuoMethodRequestToJSONTyped(value?: MfaUpdateDuoMethodRequest | null, ignoreDiscriminator?: boolean): any;
