/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface MfaUpdateOktaMethodRequest
 */
export interface MfaUpdateOktaMethodRequest {
    /**
     * Okta API key.
     * @type {string}
     * @memberof MfaUpdateOktaMethodRequest
     */
    apiToken?: string;
    /**
     * The base domain to use for the Okta API. When not specified in the configuration, "okta.com" is used.
     * @type {string}
     * @memberof MfaUpdateOktaMethodRequest
     */
    baseUrl?: string;
    /**
     * The unique name identifier for this MFA method.
     * @type {string}
     * @memberof MfaUpdateOktaMethodRequest
     */
    methodName?: string;
    /**
     * Name of the organization to be used in the Okta API.
     * @type {string}
     * @memberof MfaUpdateOktaMethodRequest
     */
    orgName?: string;
    /**
     * If true, the username will only match the primary email for the account. Defaults to false.
     * @type {boolean}
     * @memberof MfaUpdateOktaMethodRequest
     */
    primaryEmail?: boolean;
    /**
     * (DEPRECATED) Use base_url instead.
     * @type {boolean}
     * @memberof MfaUpdateOktaMethodRequest
     */
    production?: boolean;
    /**
     * A template string for mapping Identity names to MFA method names. Values to substitute should be placed in {{}}. For example, "{{entity.name}}@example.com". If blank, the Entity's name field will be used as-is.
     * @type {string}
     * @memberof MfaUpdateOktaMethodRequest
     */
    usernameFormat?: string;
}
/**
 * Check if a given object implements the MfaUpdateOktaMethodRequest interface.
 */
export declare function instanceOfMfaUpdateOktaMethodRequest(value: object): value is MfaUpdateOktaMethodRequest;
export declare function MfaUpdateOktaMethodRequestFromJSON(json: any): MfaUpdateOktaMethodRequest;
export declare function MfaUpdateOktaMethodRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): MfaUpdateOktaMethodRequest;
export declare function MfaUpdateOktaMethodRequestToJSON(json: any): MfaUpdateOktaMethodRequest;
export declare function MfaUpdateOktaMethodRequestToJSONTyped(value?: MfaUpdateOktaMethodRequest | null, ignoreDiscriminator?: boolean): any;
