/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface MongoDbAtlasWriteRoleRequest
 */
export interface MongoDbAtlasWriteRoleRequest {
    /**
     * Access list entry in CIDR notation to be added for the API key. Optional for organization and project keys.
     * @type {Array<string>}
     * @memberof MongoDbAtlasWriteRoleRequest
     */
    cidrBlocks?: Array<string>;
    /**
     * IP address to be added to the access list for the API key. Optional for organization and project keys.
     * @type {Array<string>}
     * @memberof MongoDbAtlasWriteRoleRequest
     */
    ipAddresses?: Array<string>;
    /**
     * The maximum allowed lifetime of credentials issued using this role.
     * @type {string}
     * @memberof MongoDbAtlasWriteRoleRequest
     */
    maxTtl?: string;
    /**
     * Organization ID required for an organization API key
     * @type {string}
     * @memberof MongoDbAtlasWriteRoleRequest
     */
    organizationId?: string;
    /**
     * Project ID the project API key belongs to.
     * @type {string}
     * @memberof MongoDbAtlasWriteRoleRequest
     */
    projectId?: string;
    /**
     * Roles assigned when an organization API Key is assigned to a project API key
     * @type {Array<string>}
     * @memberof MongoDbAtlasWriteRoleRequest
     */
    projectRoles?: Array<string>;
    /**
     * List of roles that the API Key should be granted. A minimum of one role must be provided. Any roles provided must be valid for the assigned Project, required for organization and project keys.
     * @type {Array<string>}
     * @memberof MongoDbAtlasWriteRoleRequest
     */
    roles: Array<string>;
    /**
     * Duration in seconds after which the issued credential should expire. Defaults to 0, in which case the value will fallback to the system/mount defaults.
     * @type {string}
     * @memberof MongoDbAtlasWriteRoleRequest
     */
    ttl?: string;
}
/**
 * Check if a given object implements the MongoDbAtlasWriteRoleRequest interface.
 */
export declare function instanceOfMongoDbAtlasWriteRoleRequest(value: object): value is MongoDbAtlasWriteRoleRequest;
export declare function MongoDbAtlasWriteRoleRequestFromJSON(json: any): MongoDbAtlasWriteRoleRequest;
export declare function MongoDbAtlasWriteRoleRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): MongoDbAtlasWriteRoleRequest;
export declare function MongoDbAtlasWriteRoleRequestToJSON(json: any): MongoDbAtlasWriteRoleRequest;
export declare function MongoDbAtlasWriteRoleRequestToJSONTyped(value?: MongoDbAtlasWriteRoleRequest | null, ignoreDiscriminator?: boolean): any;
