/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface MountsReadTuningInformationResponse
 */
export interface MountsReadTuningInformationResponse {
    /**
     *
     * @type {Array<string>}
     * @memberof MountsReadTuningInformationResponse
     */
    allowedManagedKeys?: Array<string>;
    /**
     * A list of headers to whitelist and allow a plugin to set on responses.
     * @type {Array<string>}
     * @memberof MountsReadTuningInformationResponse
     */
    allowedResponseHeaders?: Array<string>;
    /**
     *
     * @type {Array<string>}
     * @memberof MountsReadTuningInformationResponse
     */
    auditNonHmacRequestKeys?: Array<string>;
    /**
     *
     * @type {Array<string>}
     * @memberof MountsReadTuningInformationResponse
     */
    auditNonHmacResponseKeys?: Array<string>;
    /**
     * The default lease TTL for this mount.
     * @type {number}
     * @memberof MountsReadTuningInformationResponse
     */
    defaultLeaseTtl?: number;
    /**
     * A list of auth accessors that the mount is allowed to delegate authentication too
     * @type {Array<string>}
     * @memberof MountsReadTuningInformationResponse
     */
    delegatedAuthAccessors?: Array<string>;
    /**
     * User-friendly description for this credential backend.
     * @type {string}
     * @memberof MountsReadTuningInformationResponse
     */
    description?: string;
    /**
     *
     * @type {boolean}
     * @memberof MountsReadTuningInformationResponse
     */
    externalEntropyAccess?: boolean;
    /**
     *
     * @type {boolean}
     * @memberof MountsReadTuningInformationResponse
     */
    forceNoCache?: boolean;
    /**
     *
     * @type {string}
     * @memberof MountsReadTuningInformationResponse
     */
    identityTokenKey?: string;
    /**
     *
     * @type {string}
     * @memberof MountsReadTuningInformationResponse
     */
    listingVisibility?: string;
    /**
     * The max lease TTL for this mount.
     * @type {number}
     * @memberof MountsReadTuningInformationResponse
     */
    maxLeaseTtl?: number;
    /**
     * The options to pass into the backend. Should be a json object with string keys and values.
     * @type {object}
     * @memberof MountsReadTuningInformationResponse
     */
    options?: object;
    /**
     *
     * @type {Array<string>}
     * @memberof MountsReadTuningInformationResponse
     */
    passthroughRequestHeaders?: Array<string>;
    /**
     * The semantic version of the plugin to use, or image tag if oci_image is provided.
     * @type {string}
     * @memberof MountsReadTuningInformationResponse
     */
    pluginVersion?: string;
    /**
     * The type of token to issue (service or batch).
     * @type {string}
     * @memberof MountsReadTuningInformationResponse
     */
    tokenType?: string;
    /**
     *
     * @type {boolean}
     * @memberof MountsReadTuningInformationResponse
     */
    trimRequestTrailingSlashes?: boolean;
    /**
     *
     * @type {number}
     * @memberof MountsReadTuningInformationResponse
     */
    userLockoutCounterResetDuration?: number;
    /**
     *
     * @type {boolean}
     * @memberof MountsReadTuningInformationResponse
     */
    userLockoutDisable?: boolean;
    /**
     *
     * @type {number}
     * @memberof MountsReadTuningInformationResponse
     */
    userLockoutDuration?: number;
    /**
     *
     * @type {number}
     * @memberof MountsReadTuningInformationResponse
     */
    userLockoutThreshold?: number;
}
/**
 * Check if a given object implements the MountsReadTuningInformationResponse interface.
 */
export declare function instanceOfMountsReadTuningInformationResponse(value: object): value is MountsReadTuningInformationResponse;
export declare function MountsReadTuningInformationResponseFromJSON(json: any): MountsReadTuningInformationResponse;
export declare function MountsReadTuningInformationResponseFromJSONTyped(json: any, ignoreDiscriminator: boolean): MountsReadTuningInformationResponse;
export declare function MountsReadTuningInformationResponseToJSON(json: any): MountsReadTuningInformationResponse;
export declare function MountsReadTuningInformationResponseToJSONTyped(value?: MountsReadTuningInformationResponse | null, ignoreDiscriminator?: boolean): any;
