/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface OidcProviderTokenRequest
 */
export interface OidcProviderTokenRequest {
    /**
     * The ID of the requesting client.
     * @type {string}
     * @memberof OidcProviderTokenRequest
     */
    clientId?: string;
    /**
     * The secret of the requesting client.
     * @type {string}
     * @memberof OidcProviderTokenRequest
     */
    clientSecret?: string;
    /**
     * The authorization code received from the provider's authorization endpoint.
     * @type {string}
     * @memberof OidcProviderTokenRequest
     */
    code: string;
    /**
     * The code verifier associated with the authorization code.
     * @type {string}
     * @memberof OidcProviderTokenRequest
     */
    codeVerifier?: string;
    /**
     * The authorization grant type. The following grant types are supported: 'authorization_code'.
     * @type {string}
     * @memberof OidcProviderTokenRequest
     */
    grantType: string;
    /**
     * The callback location where the authentication response was sent.
     * @type {string}
     * @memberof OidcProviderTokenRequest
     */
    redirectUri: string;
}
/**
 * Check if a given object implements the OidcProviderTokenRequest interface.
 */
export declare function instanceOfOidcProviderTokenRequest(value: object): value is OidcProviderTokenRequest;
export declare function OidcProviderTokenRequestFromJSON(json: any): OidcProviderTokenRequest;
export declare function OidcProviderTokenRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): OidcProviderTokenRequest;
export declare function OidcProviderTokenRequestToJSON(json: any): OidcProviderTokenRequest;
export declare function OidcProviderTokenRequestToJSONTyped(value?: OidcProviderTokenRequest | null, ignoreDiscriminator?: boolean): any;
