/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface PkiGenerateExportedKeyRequest
 */
export interface PkiGenerateExportedKeyRequest {
    /**
     * The number of bits to use. Allowed values are 0 (universal default); with rsa key_type: 2048 (default), 3072, 4096 or 8192; with ec key_type: 224, 256 (default), 384, or 521; ignored with ed25519.
     * @type {number}
     * @memberof PkiGenerateExportedKeyRequest
     */
    keyBits?: number;
    /**
     * Optional name to be used for this key
     * @type {string}
     * @memberof PkiGenerateExportedKeyRequest
     */
    keyName?: string;
    /**
     * The type of key to use; defaults to RSA. "rsa" "ec" and "ed25519" are the only valid values.
     * @type {string}
     * @memberof PkiGenerateExportedKeyRequest
     */
    keyType?: PkiGenerateExportedKeyRequestKeyTypeEnum;
    /**
     * The name of the managed key to use when the exported type is kms. When kms type is the key type, this field or managed_key_name is required. Ignored for other types.
     * @type {string}
     * @memberof PkiGenerateExportedKeyRequest
     */
    managedKeyId?: string;
    /**
     * The name of the managed key to use when the exported type is kms. When kms type is the key type, this field or managed_key_id is required. Ignored for other types.
     * @type {string}
     * @memberof PkiGenerateExportedKeyRequest
     */
    managedKeyName?: string;
}
/**
* @export
* @enum {string}
*/
export declare enum PkiGenerateExportedKeyRequestKeyTypeEnum {
    RSA = "rsa",
    EC = "ec",
    ED25519 = "ed25519"
}
/**
 * Check if a given object implements the PkiGenerateExportedKeyRequest interface.
 */
export declare function instanceOfPkiGenerateExportedKeyRequest(value: object): value is PkiGenerateExportedKeyRequest;
export declare function PkiGenerateExportedKeyRequestFromJSON(json: any): PkiGenerateExportedKeyRequest;
export declare function PkiGenerateExportedKeyRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): PkiGenerateExportedKeyRequest;
export declare function PkiGenerateExportedKeyRequestToJSON(json: any): PkiGenerateExportedKeyRequest;
export declare function PkiGenerateExportedKeyRequestToJSONTyped(value?: PkiGenerateExportedKeyRequest | null, ignoreDiscriminator?: boolean): any;
