/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface PkiIssuerResignCrlsRequest
 */
export interface PkiIssuerResignCrlsRequest {
    /**
     * The sequence number to be written within the CRL Number extension.
     * @type {number}
     * @memberof PkiIssuerResignCrlsRequest
     */
    crlNumber?: number;
    /**
     * A list of PEM encoded CRLs to combine, originally signed by the requested issuer.
     * @type {Array<string>}
     * @memberof PkiIssuerResignCrlsRequest
     */
    crls?: Array<string>;
    /**
     * Using a zero or greater value specifies the base CRL revision number to encode within a Delta CRL indicator extension, otherwise the extension will not be added.
     * @type {number}
     * @memberof PkiIssuerResignCrlsRequest
     */
    deltaCrlBaseNumber?: number;
    /**
     * The format of the combined CRL, can be "pem" or "der". If "der", the value will be base64 encoded. Defaults to "pem".
     * @type {string}
     * @memberof PkiIssuerResignCrlsRequest
     */
    format?: string;
    /**
     * The amount of time the generated CRL should be valid; defaults to 72 hours.
     * @type {string}
     * @memberof PkiIssuerResignCrlsRequest
     */
    nextUpdate?: string;
}
/**
 * Check if a given object implements the PkiIssuerResignCrlsRequest interface.
 */
export declare function instanceOfPkiIssuerResignCrlsRequest(value: object): value is PkiIssuerResignCrlsRequest;
export declare function PkiIssuerResignCrlsRequestFromJSON(json: any): PkiIssuerResignCrlsRequest;
export declare function PkiIssuerResignCrlsRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): PkiIssuerResignCrlsRequest;
export declare function PkiIssuerResignCrlsRequestToJSON(json: any): PkiIssuerResignCrlsRequest;
export declare function PkiIssuerResignCrlsRequestToJSONTyped(value?: PkiIssuerResignCrlsRequest | null, ignoreDiscriminator?: boolean): any;
