/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface PkiReadAutoTidyConfigurationResponse
 */
export interface PkiReadAutoTidyConfigurationResponse {
    /**
     * Safety buffer after creation after which accounts lacking orders are revoked
     * @type {number}
     * @memberof PkiReadAutoTidyConfigurationResponse
     */
    acmeAccountSafetyBuffer?: number;
    /**
     * Specifies whether automatic tidy is enabled or not
     * @type {boolean}
     * @memberof PkiReadAutoTidyConfigurationResponse
     */
    enabled?: boolean;
    /**
     * Specifies the duration between automatic tidy operation
     * @type {number}
     * @memberof PkiReadAutoTidyConfigurationResponse
     */
    intervalDuration?: number;
    /**
     * Issuer safety buffer
     * @type {number}
     * @memberof PkiReadAutoTidyConfigurationResponse
     */
    issuerSafetyBuffer?: number;
    /**
     *
     * @type {boolean}
     * @memberof PkiReadAutoTidyConfigurationResponse
     */
    maintainStoredCertificateCounts?: boolean;
    /**
     * The maximum amount of time in seconds auto-tidy will be delayed after startup
     * @type {number}
     * @memberof PkiReadAutoTidyConfigurationResponse
     */
    maxStartupBackoffDuration?: number;
    /**
     * The minimum amount of time in seconds auto-tidy will be delayed after startup
     * @type {number}
     * @memberof PkiReadAutoTidyConfigurationResponse
     */
    minStartupBackoffDuration?: number;
    /**
     * Duration to pause between tidying certificates
     * @type {string}
     * @memberof PkiReadAutoTidyConfigurationResponse
     */
    pauseDuration?: string;
    /**
     *
     * @type {boolean}
     * @memberof PkiReadAutoTidyConfigurationResponse
     */
    publishStoredCertificateCountMetrics?: boolean;
    /**
     *
     * @type {number}
     * @memberof PkiReadAutoTidyConfigurationResponse
     */
    revocationQueueSafetyBuffer?: number;
    /**
     * Safety buffer time duration
     * @type {number}
     * @memberof PkiReadAutoTidyConfigurationResponse
     */
    safetyBuffer?: number;
    /**
     * Tidy Unused Acme Accounts, and Orders
     * @type {boolean}
     * @memberof PkiReadAutoTidyConfigurationResponse
     */
    tidyAcme?: boolean;
    /**
     * Tidy cert metadata
     * @type {boolean}
     * @memberof PkiReadAutoTidyConfigurationResponse
     */
    tidyCertMetadata?: boolean;
    /**
     * Specifies whether to tidy up the certificate store
     * @type {boolean}
     * @memberof PkiReadAutoTidyConfigurationResponse
     */
    tidyCertStore?: boolean;
    /**
     * Tidy CMPv2 nonce store
     * @type {boolean}
     * @memberof PkiReadAutoTidyConfigurationResponse
     */
    tidyCmpv2NonceStore?: boolean;
    /**
     * Tidy the cross-cluster revoked certificate store
     * @type {boolean}
     * @memberof PkiReadAutoTidyConfigurationResponse
     */
    tidyCrossClusterRevokedCerts?: boolean;
    /**
     * Specifies whether tidy expired issuers
     * @type {boolean}
     * @memberof PkiReadAutoTidyConfigurationResponse
     */
    tidyExpiredIssuers?: boolean;
    /**
     *
     * @type {boolean}
     * @memberof PkiReadAutoTidyConfigurationResponse
     */
    tidyMoveLegacyCaBundle?: boolean;
    /**
     *
     * @type {boolean}
     * @memberof PkiReadAutoTidyConfigurationResponse
     */
    tidyRevocationQueue?: boolean;
    /**
     * Specifies whether to associate revoked certificates with their corresponding issuers
     * @type {boolean}
     * @memberof PkiReadAutoTidyConfigurationResponse
     */
    tidyRevokedCertIssuerAssociations?: boolean;
    /**
     * Specifies whether to remove all invalid and expired certificates from storage
     * @type {boolean}
     * @memberof PkiReadAutoTidyConfigurationResponse
     */
    tidyRevokedCerts?: boolean;
}
/**
 * Check if a given object implements the PkiReadAutoTidyConfigurationResponse interface.
 */
export declare function instanceOfPkiReadAutoTidyConfigurationResponse(value: object): value is PkiReadAutoTidyConfigurationResponse;
export declare function PkiReadAutoTidyConfigurationResponseFromJSON(json: any): PkiReadAutoTidyConfigurationResponse;
export declare function PkiReadAutoTidyConfigurationResponseFromJSONTyped(json: any, ignoreDiscriminator: boolean): PkiReadAutoTidyConfigurationResponse;
export declare function PkiReadAutoTidyConfigurationResponseToJSON(json: any): PkiReadAutoTidyConfigurationResponse;
export declare function PkiReadAutoTidyConfigurationResponseToJSONTyped(value?: PkiReadAutoTidyConfigurationResponse | null, ignoreDiscriminator?: boolean): any;
