/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface PkiWriteExternalPolicyIssueRequest
 */
export interface PkiWriteExternalPolicyIssueRequest {
    [key: string]: any | any;
    /**
     * Format for returned data. Can be "pem", "der", or "pem_bundle". If "pem_bundle", any private key and issuing cert will be appended to the certificate pem. If "der", the value will be base64 encoded. Defaults to "pem".
     * @type {string}
     * @memberof PkiWriteExternalPolicyIssueRequest
     */
    format?: PkiWriteExternalPolicyIssueRequestFormatEnum;
    /**
     * The number of bits to use. Allowed values are 0 (universal default); with rsa key_type: 2048 (default), 3072, or 4096; with ec key_type: 224, 256 (default), 384, or 521; ignored with ed25519.
     * @type {number}
     * @memberof PkiWriteExternalPolicyIssueRequest
     */
    keyBits?: number;
    /**
     * The type of key to use; defaults to RSA. "rsa" "ec" and "ed25519" are the only valid values.
     * @type {string}
     * @memberof PkiWriteExternalPolicyIssueRequest
     */
    keyType?: PkiWriteExternalPolicyIssueRequestKeyTypeEnum;
    /**
     * Format for the returned private key. Generally the default will be controlled by the "format" parameter as either base64-encoded DER or PEM-encoded DER. However, this can be set to "pkcs8" to have the returned private key contain base64-encoded pkcs8 or PEM-encoded pkcs8 instead. Defaults to "der".
     * @type {string}
     * @memberof PkiWriteExternalPolicyIssueRequest
     */
    privateKeyFormat?: PkiWriteExternalPolicyIssueRequestPrivateKeyFormatEnum;
    /**
     * Whether or not to remove self-signed CA certificates in the output of the ca_chain field.
     * @type {boolean}
     * @memberof PkiWriteExternalPolicyIssueRequest
     */
    removeRootsFromChain?: boolean;
}
/**
* @export
* @enum {string}
*/
export declare enum PkiWriteExternalPolicyIssueRequestFormatEnum {
    PEM = "pem",
    DER = "der",
    PEM_BUNDLE = "pem_bundle"
}
/**
* @export
* @enum {string}
*/
export declare enum PkiWriteExternalPolicyIssueRequestKeyTypeEnum {
    RSA = "rsa",
    EC = "ec",
    ED25519 = "ed25519"
}
/**
* @export
* @enum {string}
*/
export declare enum PkiWriteExternalPolicyIssueRequestPrivateKeyFormatEnum {
    DER = "der",
    PEM = "pem",
    PKCS8 = "pkcs8"
}
/**
 * Check if a given object implements the PkiWriteExternalPolicyIssueRequest interface.
 */
export declare function instanceOfPkiWriteExternalPolicyIssueRequest(value: object): value is PkiWriteExternalPolicyIssueRequest;
export declare function PkiWriteExternalPolicyIssueRequestFromJSON(json: any): PkiWriteExternalPolicyIssueRequest;
export declare function PkiWriteExternalPolicyIssueRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): PkiWriteExternalPolicyIssueRequest;
export declare function PkiWriteExternalPolicyIssueRequestToJSON(json: any): PkiWriteExternalPolicyIssueRequest;
export declare function PkiWriteExternalPolicyIssueRequestToJSONTyped(value?: PkiWriteExternalPolicyIssueRequest | null, ignoreDiscriminator?: boolean): any;
