/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface PkiWriteExternalPolicySignRequest
 */
export interface PkiWriteExternalPolicySignRequest {
    [key: string]: any | any;
    /**
     * PEM-format CSR is expected but the contents of this field will not be validated
     * @type {string}
     * @memberof PkiWriteExternalPolicySignRequest
     */
    csr: string;
    /**
     * Format for returned data. Can be "pem", "der", or "pem_bundle". If "pem_bundle", any private key and issuing cert will be appended to the certificate pem. If "der", the value will be base64 encoded. Defaults to "pem".
     * @type {string}
     * @memberof PkiWriteExternalPolicySignRequest
     */
    format?: PkiWriteExternalPolicySignRequestFormatEnum;
    /**
     * Whether or not to remove self-signed CA certificates in the output of the ca_chain field.
     * @type {boolean}
     * @memberof PkiWriteExternalPolicySignRequest
     */
    removeRootsFromChain?: boolean;
}
/**
* @export
* @enum {string}
*/
export declare enum PkiWriteExternalPolicySignRequestFormatEnum {
    PEM = "pem",
    DER = "der",
    PEM_BUNDLE = "pem_bundle"
}
/**
 * Check if a given object implements the PkiWriteExternalPolicySignRequest interface.
 */
export declare function instanceOfPkiWriteExternalPolicySignRequest(value: object): value is PkiWriteExternalPolicySignRequest;
export declare function PkiWriteExternalPolicySignRequestFromJSON(json: any): PkiWriteExternalPolicySignRequest;
export declare function PkiWriteExternalPolicySignRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): PkiWriteExternalPolicySignRequest;
export declare function PkiWriteExternalPolicySignRequestToJSON(json: any): PkiWriteExternalPolicySignRequest;
export declare function PkiWriteExternalPolicySignRequestToJSONTyped(value?: PkiWriteExternalPolicySignRequest | null, ignoreDiscriminator?: boolean): any;
