/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface PluginsCatalogRegisterPluginRequest
 */
export interface PluginsCatalogRegisterPluginRequest {
    /**
     * The args passed to plugin command.
     * @type {Array<string>}
     * @memberof PluginsCatalogRegisterPluginRequest
     */
    args?: Array<string>;
    /**
     * The command used to start the plugin. The executable defined in this command must exist in vault's plugin directory.
     * @type {string}
     * @memberof PluginsCatalogRegisterPluginRequest
     */
    command?: string;
    /**
     * The environment variables passed to plugin command. Each entry is of the form "key=value".
     * @type {Array<string>}
     * @memberof PluginsCatalogRegisterPluginRequest
     */
    env?: Array<string>;
    /**
     *
     * @type {string}
     * @memberof PluginsCatalogRegisterPluginRequest
     */
    ociImage?: string;
    /**
     * The Vault plugin runtime to use when running the plugin.
     * @type {string}
     * @memberof PluginsCatalogRegisterPluginRequest
     */
    runtime?: string;
    /**
     * The SHA256 sum of the executable or container to be run. This should be HEX encoded.
     * @type {string}
     * @memberof PluginsCatalogRegisterPluginRequest
     */
    sha256?: string;
    /**
     * The semantic version of the plugin to use, or image tag if oci_image is provided.
     * @type {string}
     * @memberof PluginsCatalogRegisterPluginRequest
     */
    version?: string;
}
/**
 * Check if a given object implements the PluginsCatalogRegisterPluginRequest interface.
 */
export declare function instanceOfPluginsCatalogRegisterPluginRequest(value: object): value is PluginsCatalogRegisterPluginRequest;
export declare function PluginsCatalogRegisterPluginRequestFromJSON(json: any): PluginsCatalogRegisterPluginRequest;
export declare function PluginsCatalogRegisterPluginRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): PluginsCatalogRegisterPluginRequest;
export declare function PluginsCatalogRegisterPluginRequestToJSON(json: any): PluginsCatalogRegisterPluginRequest;
export declare function PluginsCatalogRegisterPluginRequestToJSONTyped(value?: PluginsCatalogRegisterPluginRequest | null, ignoreDiscriminator?: boolean): any;
