/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface SshConfigureCaRequest
 */
export interface SshConfigureCaRequest {
    /**
     * Generate SSH key pair internally rather than use the private_key and public_key fields. If managed key config is provided, this field is ignored.
     * @type {boolean}
     * @memberof SshConfigureCaRequest
     */
    generateSigningKey?: boolean;
    /**
     * Specifies the desired key bits when generating variable-length keys (such as when key_type="ssh-rsa") or which NIST P-curve to use when key_type="ec" (256, 384, or 521).
     * @type {number}
     * @memberof SshConfigureCaRequest
     */
    keyBits?: number;
    /**
     * Specifies the desired key type when generating; could be a OpenSSH key type identifier (ssh-rsa, ecdsa-sha2-nistp256, ecdsa-sha2-nistp384, ecdsa-sha2-nistp521, or ssh-ed25519) or an algorithm (rsa, ec, ed25519).
     * @type {string}
     * @memberof SshConfigureCaRequest
     */
    keyType?: string;
    /**
     * The id of the managed key to use. When using a managed key, this field or managed_key_name is required.
     * @type {string}
     * @memberof SshConfigureCaRequest
     */
    managedKeyId?: string;
    /**
     * The name of the managed key to use. When using a managed key, this field or managed_key_id is required.
     * @type {string}
     * @memberof SshConfigureCaRequest
     */
    managedKeyName?: string;
    /**
     * Private half of the SSH key that will be used to sign certificates.
     * @type {string}
     * @memberof SshConfigureCaRequest
     */
    privateKey?: string;
    /**
     * Public half of the SSH key that will be used to sign certificates.
     * @type {string}
     * @memberof SshConfigureCaRequest
     */
    publicKey?: string;
}
/**
 * Check if a given object implements the SshConfigureCaRequest interface.
 */
export declare function instanceOfSshConfigureCaRequest(value: object): value is SshConfigureCaRequest;
export declare function SshConfigureCaRequestFromJSON(json: any): SshConfigureCaRequest;
export declare function SshConfigureCaRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): SshConfigureCaRequest;
export declare function SshConfigureCaRequestToJSON(json: any): SshConfigureCaRequest;
export declare function SshConfigureCaRequestToJSONTyped(value?: SshConfigureCaRequest | null, ignoreDiscriminator?: boolean): any;
