/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface AppRoleLookUpSecretIdResponse
 */
export interface AppRoleLookUpSecretIdResponse {
    /**
     * List of CIDR blocks enforcing secret IDs to be used from specific set of IP addresses. If 'bound_cidr_list' is set on the role, then the list of CIDR blocks listed here should be a subset of the CIDR blocks listed on the role.
     * @type {Array<string>}
     * @memberof AppRoleLookUpSecretIdResponse
     */
    cidrList?: Array<string>;
    /**
     *
     * @type {Date}
     * @memberof AppRoleLookUpSecretIdResponse
     */
    creationTime?: Date;
    /**
     *
     * @type {Date}
     * @memberof AppRoleLookUpSecretIdResponse
     */
    expirationTime?: Date;
    /**
     *
     * @type {Date}
     * @memberof AppRoleLookUpSecretIdResponse
     */
    lastUpdatedTime?: Date;
    /**
     *
     * @type {object}
     * @memberof AppRoleLookUpSecretIdResponse
     */
    metadata?: object;
    /**
     * Accessor of the secret ID
     * @type {string}
     * @memberof AppRoleLookUpSecretIdResponse
     */
    secretIdAccessor?: string;
    /**
     * Number of times a secret ID can access the role, after which the secret ID will expire.
     * @type {number}
     * @memberof AppRoleLookUpSecretIdResponse
     */
    secretIdNumUses?: number;
    /**
     * Duration in seconds after which the issued secret ID expires.
     * @type {number}
     * @memberof AppRoleLookUpSecretIdResponse
     */
    secretIdTtl?: number;
    /**
     * List of CIDR blocks. If set, specifies the blocks of IP addresses which can use the returned token. Should be a subset of the token CIDR blocks listed on the role, if any.
     * @type {Array<string>}
     * @memberof AppRoleLookUpSecretIdResponse
     */
    tokenBoundCidrs?: Array<string>;
}
/**
 * Check if a given object implements the AppRoleLookUpSecretIdResponse interface.
 */
export declare function instanceOfAppRoleLookUpSecretIdResponse(value: object): value is AppRoleLookUpSecretIdResponse;
export declare function AppRoleLookUpSecretIdResponseFromJSON(json: any): AppRoleLookUpSecretIdResponse;
export declare function AppRoleLookUpSecretIdResponseFromJSONTyped(json: any, ignoreDiscriminator: boolean): AppRoleLookUpSecretIdResponse;
export declare function AppRoleLookUpSecretIdResponseToJSON(json: any): AppRoleLookUpSecretIdResponse;
export declare function AppRoleLookUpSecretIdResponseToJSONTyped(value?: AppRoleLookUpSecretIdResponse | null, ignoreDiscriminator?: boolean): any;
