/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface AwsConfigureIdentityIntegrationRequest
 */
export interface AwsConfigureIdentityIntegrationRequest {
    /**
     * Configure how the AWS auth method generates entity alias when using EC2 auth. Valid values are "role_id", "instance_id", and "image_id". Defaults to "role_id".
     * @type {string}
     * @memberof AwsConfigureIdentityIntegrationRequest
     */
    ec2Alias?: string;
    /**
     * The metadata to include on the aliases and audit logs generated by this plugin. When set to 'default', includes: account_id, auth_type. These fields are available to add: ami_id, instance_id, region. Not editing this field means the 'default' fields are included. Explicitly setting this field to empty overrides the 'default' and means no metadata will be included. If not using 'default', explicit fields must be sent like: 'field1,field2'.
     * @type {Array<string>}
     * @memberof AwsConfigureIdentityIntegrationRequest
     */
    ec2Metadata?: Array<string>;
    /**
     * Configure how the AWS auth method generates entity aliases when using IAM auth. Valid values are "role_id", "unique_id", "full_arn" and "canonical_arn". Defaults to "role_id".
     * @type {string}
     * @memberof AwsConfigureIdentityIntegrationRequest
     */
    iamAlias?: string;
    /**
     * The metadata to include on the aliases and audit logs generated by this plugin. When set to 'default', includes: account_id, auth_type. These fields are available to add: canonical_arn, client_arn, client_user_id, inferred_aws_region, inferred_entity_id, inferred_entity_type, inferred_hostname. Not editing this field means the 'default' fields are included. Explicitly setting this field to empty overrides the 'default' and means no metadata will be included. If not using 'default', explicit fields must be sent like: 'field1,field2'.
     * @type {Array<string>}
     * @memberof AwsConfigureIdentityIntegrationRequest
     */
    iamMetadata?: Array<string>;
}
/**
 * Check if a given object implements the AwsConfigureIdentityIntegrationRequest interface.
 */
export declare function instanceOfAwsConfigureIdentityIntegrationRequest(value: object): value is AwsConfigureIdentityIntegrationRequest;
export declare function AwsConfigureIdentityIntegrationRequestFromJSON(json: any): AwsConfigureIdentityIntegrationRequest;
export declare function AwsConfigureIdentityIntegrationRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): AwsConfigureIdentityIntegrationRequest;
export declare function AwsConfigureIdentityIntegrationRequestToJSON(json: any): AwsConfigureIdentityIntegrationRequest;
export declare function AwsConfigureIdentityIntegrationRequestToJSONTyped(value?: AwsConfigureIdentityIntegrationRequest | null, ignoreDiscriminator?: boolean): any;
