/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface AwsWriteRoleTagRequest
 */
export interface AwsWriteRoleTagRequest {
    /**
     * If set, allows migration of the underlying instance where the client resides. This keys off of pendingTime in the metadata document, so essentially, this disables the client nonce check whenever the instance is migrated to a new host and pendingTime is newer than the previously-remembered time. Use with caution.
     * @type {boolean}
     * @memberof AwsWriteRoleTagRequest
     */
    allowInstanceMigration?: boolean;
    /**
     * If set, only allows a single token to be granted per instance ID. In order to perform a fresh login, the entry in access list for the instance ID needs to be cleared using the 'auth/aws-ec2/identity-accesslist/<instance_id>' endpoint.
     * @type {boolean}
     * @memberof AwsWriteRoleTagRequest
     */
    disallowReauthentication?: boolean;
    /**
     * Instance ID for which this tag is intended for. If set, the created tag can only be used by the instance with the given ID.
     * @type {string}
     * @memberof AwsWriteRoleTagRequest
     */
    instanceId?: string;
    /**
     * If set, specifies the maximum allowed token lifetime.
     * @type {string}
     * @memberof AwsWriteRoleTagRequest
     */
    maxTtl?: string;
    /**
     * Policies to be associated with the tag. If set, must be a subset of the role's policies. If set, but set to an empty value, only the 'default' policy will be given to issued tokens.
     * @type {Array<string>}
     * @memberof AwsWriteRoleTagRequest
     */
    policies?: Array<string>;
}
/**
 * Check if a given object implements the AwsWriteRoleTagRequest interface.
 */
export declare function instanceOfAwsWriteRoleTagRequest(value: object): value is AwsWriteRoleTagRequest;
export declare function AwsWriteRoleTagRequestFromJSON(json: any): AwsWriteRoleTagRequest;
export declare function AwsWriteRoleTagRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): AwsWriteRoleTagRequest;
export declare function AwsWriteRoleTagRequestToJSON(json: any): AwsWriteRoleTagRequest;
export declare function AwsWriteRoleTagRequestToJSONTyped(value?: AwsWriteRoleTagRequest | null, ignoreDiscriminator?: boolean): any;
