/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface CertConfigureRequest
 */
export interface CertConfigureRequest {
    /**
     * If set, during renewal, skips the matching of presented client identity with the client identity used during login. Defaults to false.
     * @type {boolean}
     * @memberof CertConfigureRequest
     */
    disableBinding?: boolean;
    /**
     * If set, metadata of the certificate including the metadata corresponding to allowed_metadata_extensions will be stored in the alias. Defaults to false.
     * @type {boolean}
     * @memberof CertConfigureRequest
     */
    enableIdentityAliasMetadata?: boolean;
    /**
     * If set, metadata of the client certificate will be returned on authentication failures.
     * @type {boolean}
     * @memberof CertConfigureRequest
     */
    enableMetadataOnFailures?: boolean;
    /**
     * The size of the in memory OCSP response cache, shared by all configured certs
     * @type {number}
     * @memberof CertConfigureRequest
     */
    ocspCacheSize?: number;
    /**
     * The size of the in memory role cache
     * @type {number}
     * @memberof CertConfigureRequest
     */
    roleCacheSize?: number;
}
/**
 * Check if a given object implements the CertConfigureRequest interface.
 */
export declare function instanceOfCertConfigureRequest(value: object): value is CertConfigureRequest;
export declare function CertConfigureRequestFromJSON(json: any): CertConfigureRequest;
export declare function CertConfigureRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): CertConfigureRequest;
export declare function CertConfigureRequestToJSON(json: any): CertConfigureRequest;
export declare function CertConfigureRequestToJSONTyped(value?: CertConfigureRequest | null, ignoreDiscriminator?: boolean): any;
