/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface ConsulConfigureAccessRequest
 */
export interface ConsulConfigureAccessRequest {
    /**
     * Consul server address
     * @type {string}
     * @memberof ConsulConfigureAccessRequest
     */
    address?: string;
    /**
     * CA certificate to use when verifying Consul server certificate, must be x509 PEM encoded.
     * @type {string}
     * @memberof ConsulConfigureAccessRequest
     */
    caCert?: string;
    /**
     * Client certificate used for Consul's TLS communication, must be x509 PEM encoded and if this is set you need to also set client_key.
     * @type {string}
     * @memberof ConsulConfigureAccessRequest
     */
    clientCert?: string;
    /**
     * Client key used for Consul's TLS communication, must be x509 PEM encoded and if this is set you need to also set client_cert.
     * @type {string}
     * @memberof ConsulConfigureAccessRequest
     */
    clientKey?: string;
    /**
     * URI scheme for the Consul address
     * @type {string}
     * @memberof ConsulConfigureAccessRequest
     */
    scheme?: string;
    /**
     * Token for API calls
     * @type {string}
     * @memberof ConsulConfigureAccessRequest
     */
    token?: string;
}
/**
 * Check if a given object implements the ConsulConfigureAccessRequest interface.
 */
export declare function instanceOfConsulConfigureAccessRequest(value: object): value is ConsulConfigureAccessRequest;
export declare function ConsulConfigureAccessRequestFromJSON(json: any): ConsulConfigureAccessRequest;
export declare function ConsulConfigureAccessRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): ConsulConfigureAccessRequest;
export declare function ConsulConfigureAccessRequestToJSON(json: any): ConsulConfigureAccessRequest;
export declare function ConsulConfigureAccessRequestToJSONTyped(value?: ConsulConfigureAccessRequest | null, ignoreDiscriminator?: boolean): any;
