/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface EntityCreateRequest
 */
export interface EntityCreateRequest {
    /**
     * If set true, tokens tied to this identity will not be able to be used (but will not be revoked).
     * @type {boolean}
     * @memberof EntityCreateRequest
     */
    disabled?: boolean;
    /**
     * ID of the entity. If set, updates the corresponding existing entity.
     * @type {string}
     * @memberof EntityCreateRequest
     */
    id?: string;
    /**
     * Metadata to be associated with the entity. In CLI, this parameter can be repeated multiple times, and it all gets merged together. For example: vault <command> <path> metadata=key1=value1 metadata=key2=value2
     * @type {object}
     * @memberof EntityCreateRequest
     */
    metadata?: object;
    /**
     * Name of the entity
     * @type {string}
     * @memberof EntityCreateRequest
     */
    name?: string;
    /**
     * Policies to be tied to the entity.
     * @type {Array<string>}
     * @memberof EntityCreateRequest
     */
    policies?: Array<string>;
}
/**
 * Check if a given object implements the EntityCreateRequest interface.
 */
export declare function instanceOfEntityCreateRequest(value: object): value is EntityCreateRequest;
export declare function EntityCreateRequestFromJSON(json: any): EntityCreateRequest;
export declare function EntityCreateRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): EntityCreateRequest;
export declare function EntityCreateRequestToJSON(json: any): EntityCreateRequest;
export declare function EntityCreateRequestToJSONTyped(value?: EntityCreateRequest | null, ignoreDiscriminator?: boolean): any;
