/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface GoogleCloudKmsRegisterKeyRequest
 */
export interface GoogleCloudKmsRegisterKeyRequest {
    /**
     * Full resource ID of the crypto key including the project, location, key ring, and crypto key like "projects/%s/locations/%s/keyRings/%s/cryptoKeys/%s". This crypto key must already exist in Google Cloud KMS unless verify is set to "false".
     * @type {string}
     * @memberof GoogleCloudKmsRegisterKeyRequest
     */
    cryptoKey?: string;
    /**
     * Verify that the given Google Cloud KMS crypto key exists and is accessible before creating the storage entry in Vault. Set this to "false" if the key will not exist at creation time.
     * @type {boolean}
     * @memberof GoogleCloudKmsRegisterKeyRequest
     */
    verify?: boolean;
}
/**
 * Check if a given object implements the GoogleCloudKmsRegisterKeyRequest interface.
 */
export declare function instanceOfGoogleCloudKmsRegisterKeyRequest(value: object): value is GoogleCloudKmsRegisterKeyRequest;
export declare function GoogleCloudKmsRegisterKeyRequestFromJSON(json: any): GoogleCloudKmsRegisterKeyRequest;
export declare function GoogleCloudKmsRegisterKeyRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): GoogleCloudKmsRegisterKeyRequest;
export declare function GoogleCloudKmsRegisterKeyRequestToJSON(json: any): GoogleCloudKmsRegisterKeyRequest;
export declare function GoogleCloudKmsRegisterKeyRequestToJSONTyped(value?: GoogleCloudKmsRegisterKeyRequest | null, ignoreDiscriminator?: boolean): any;
