/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface KubernetesGenerateCredentialsRequest
 */
export interface KubernetesGenerateCredentialsRequest {
    /**
     * The intended audiences of the generated credentials
     * @type {Array<string>}
     * @memberof KubernetesGenerateCredentialsRequest
     */
    audiences?: Array<string>;
    /**
     * If true, generate a ClusterRoleBinding to grant permissions across the whole cluster instead of within a namespace. Requires the Vault role to have kubernetes_role_type set to ClusterRole.
     * @type {boolean}
     * @memberof KubernetesGenerateCredentialsRequest
     */
    clusterRoleBinding?: boolean;
    /**
     * The name of the Kubernetes namespace in which to generate the credentials
     * @type {string}
     * @memberof KubernetesGenerateCredentialsRequest
     */
    kubernetesNamespace: string;
    /**
     * The TTL of the generated credentials
     * @type {string}
     * @memberof KubernetesGenerateCredentialsRequest
     */
    ttl?: string;
}
/**
 * Check if a given object implements the KubernetesGenerateCredentialsRequest interface.
 */
export declare function instanceOfKubernetesGenerateCredentialsRequest(value: object): value is KubernetesGenerateCredentialsRequest;
export declare function KubernetesGenerateCredentialsRequestFromJSON(json: any): KubernetesGenerateCredentialsRequest;
export declare function KubernetesGenerateCredentialsRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): KubernetesGenerateCredentialsRequest;
export declare function KubernetesGenerateCredentialsRequestToJSON(json: any): KubernetesGenerateCredentialsRequest;
export declare function KubernetesGenerateCredentialsRequestToJSONTyped(value?: KubernetesGenerateCredentialsRequest | null, ignoreDiscriminator?: boolean): any;
