/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface KvV2PatchMetadataPathRequest
 */
export interface KvV2PatchMetadataPathRequest {
    /**
     * If true the key will require the cas parameter to be set on all write requests. If false, the backend’s configuration will be used.
     * @type {boolean}
     * @memberof KvV2PatchMetadataPathRequest
     */
    casRequired?: boolean;
    /**
     * User-provided key-value pairs that are used to describe arbitrary and version-agnostic information about a secret.
     * @type {object}
     * @memberof KvV2PatchMetadataPathRequest
     */
    customMetadata?: object;
    /**
     * The length of time before a version is deleted. If not set, the backend's configured delete_version_after is used. Cannot be greater than the backend's delete_version_after. A zero duration clears the current setting. A negative duration will cause an error.
     * @type {string}
     * @memberof KvV2PatchMetadataPathRequest
     */
    deleteVersionAfter?: string;
    /**
     * The number of versions to keep. If not set, the backend’s configured max version is used.
     * @type {number}
     * @memberof KvV2PatchMetadataPathRequest
     */
    maxVersions?: number;
}
/**
 * Check if a given object implements the KvV2PatchMetadataPathRequest interface.
 */
export declare function instanceOfKvV2PatchMetadataPathRequest(value: object): value is KvV2PatchMetadataPathRequest;
export declare function KvV2PatchMetadataPathRequestFromJSON(json: any): KvV2PatchMetadataPathRequest;
export declare function KvV2PatchMetadataPathRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): KvV2PatchMetadataPathRequest;
export declare function KvV2PatchMetadataPathRequestToJSON(json: any): KvV2PatchMetadataPathRequest;
export declare function KvV2PatchMetadataPathRequestToJSONTyped(value?: KvV2PatchMetadataPathRequest | null, ignoreDiscriminator?: boolean): any;
