/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface KvV2WriteMetadataRequest
 */
export interface KvV2WriteMetadataRequest {
    /**
     * If true the key will require the cas parameter to be set on all write requests. If false, the backend’s configuration will be used.
     * @type {boolean}
     * @memberof KvV2WriteMetadataRequest
     */
    casRequired?: boolean;
    /**
     * User-provided key-value pairs that are used to describe arbitrary and version-agnostic information about a secret.
     * @type {object}
     * @memberof KvV2WriteMetadataRequest
     */
    customMetadata?: object;
    /**
     * The length of time before a version is deleted. If not set, the backend's configured delete_version_after is used. Cannot be greater than the backend's delete_version_after. A zero duration clears the current setting. A negative duration will cause an error.
     * @type {string}
     * @memberof KvV2WriteMetadataRequest
     */
    deleteVersionAfter?: string;
    /**
     * The number of versions to keep. If not set, the backend’s configured max version is used.
     * @type {number}
     * @memberof KvV2WriteMetadataRequest
     */
    maxVersions?: number;
}
/**
 * Check if a given object implements the KvV2WriteMetadataRequest interface.
 */
export declare function instanceOfKvV2WriteMetadataRequest(value: object): value is KvV2WriteMetadataRequest;
export declare function KvV2WriteMetadataRequestFromJSON(json: any): KvV2WriteMetadataRequest;
export declare function KvV2WriteMetadataRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): KvV2WriteMetadataRequest;
export declare function KvV2WriteMetadataRequestToJSON(json: any): KvV2WriteMetadataRequest;
export declare function KvV2WriteMetadataRequestToJSONTyped(value?: KvV2WriteMetadataRequest | null, ignoreDiscriminator?: boolean): any;
