/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface LdapWriteDynamicRoleRequest
 */
export interface LdapWriteDynamicRoleRequest {
    /**
     * LDIF string used to create new entities within the LDAP system. This LDIF can be templated.
     * @type {string}
     * @memberof LdapWriteDynamicRoleRequest
     */
    creationLdif: string;
    /**
     * Default TTL for dynamic credentials
     * @type {string}
     * @memberof LdapWriteDynamicRoleRequest
     */
    defaultTtl?: string;
    /**
     * LDIF string used to delete entities created within the LDAP system. This LDIF can be templated.
     * @type {string}
     * @memberof LdapWriteDynamicRoleRequest
     */
    deletionLdif: string;
    /**
     * Max TTL a dynamic credential can be extended to
     * @type {string}
     * @memberof LdapWriteDynamicRoleRequest
     */
    maxTtl?: string;
    /**
     * LDIF string used to rollback changes in the event of a failure to create credentials. This LDIF can be templated.
     * @type {string}
     * @memberof LdapWriteDynamicRoleRequest
     */
    rollbackLdif?: string;
    /**
     * The template used to create a username
     * @type {string}
     * @memberof LdapWriteDynamicRoleRequest
     */
    usernameTemplate?: string;
}
/**
 * Check if a given object implements the LdapWriteDynamicRoleRequest interface.
 */
export declare function instanceOfLdapWriteDynamicRoleRequest(value: object): value is LdapWriteDynamicRoleRequest;
export declare function LdapWriteDynamicRoleRequestFromJSON(json: any): LdapWriteDynamicRoleRequest;
export declare function LdapWriteDynamicRoleRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): LdapWriteDynamicRoleRequest;
export declare function LdapWriteDynamicRoleRequestToJSON(json: any): LdapWriteDynamicRoleRequest;
export declare function LdapWriteDynamicRoleRequestToJSONTyped(value?: LdapWriteDynamicRoleRequest | null, ignoreDiscriminator?: boolean): any;
