/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface NomadConfigureAccessRequest
 */
export interface NomadConfigureAccessRequest {
    /**
     * Nomad server address
     * @type {string}
     * @memberof NomadConfigureAccessRequest
     */
    address?: string;
    /**
     * CA certificate to use when verifying Nomad server certificate, must be x509 PEM encoded.
     * @type {string}
     * @memberof NomadConfigureAccessRequest
     */
    caCert?: string;
    /**
     * Client certificate used for Nomad's TLS communication, must be x509 PEM encoded and if this is set you need to also set client_key.
     * @type {string}
     * @memberof NomadConfigureAccessRequest
     */
    clientCert?: string;
    /**
     * Client key used for Nomad's TLS communication, must be x509 PEM encoded and if this is set you need to also set client_cert.
     * @type {string}
     * @memberof NomadConfigureAccessRequest
     */
    clientKey?: string;
    /**
     * Max length for name of generated Nomad tokens
     * @type {number}
     * @memberof NomadConfigureAccessRequest
     */
    maxTokenNameLength?: number;
    /**
     * Token for API calls
     * @type {string}
     * @memberof NomadConfigureAccessRequest
     */
    token?: string;
}
/**
 * Check if a given object implements the NomadConfigureAccessRequest interface.
 */
export declare function instanceOfNomadConfigureAccessRequest(value: object): value is NomadConfigureAccessRequest;
export declare function NomadConfigureAccessRequestFromJSON(json: any): NomadConfigureAccessRequest;
export declare function NomadConfigureAccessRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): NomadConfigureAccessRequest;
export declare function NomadConfigureAccessRequestToJSON(json: any): NomadConfigureAccessRequest;
export declare function NomadConfigureAccessRequestToJSONTyped(value?: NomadConfigureAccessRequest | null, ignoreDiscriminator?: boolean): any;
