/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface PkiConfigureAcmeRequest
 */
export interface PkiConfigureAcmeRequest {
    /**
     * whether the ExtKeyUsage field from a role is used, defaults to false meaning that certificate will be signed with ServerAuth.
     * @type {boolean}
     * @memberof PkiConfigureAcmeRequest
     */
    allowRoleExtKeyUsage?: boolean;
    /**
     * which issuers are allowed for use with ACME; by default, this will only be the primary (default) issuer
     * @type {Array<string>}
     * @memberof PkiConfigureAcmeRequest
     */
    allowedIssuers?: Array<string>;
    /**
     * which roles are allowed for use with ACME; by default via '*', these will be all roles including sign-verbatim; when concrete role names are specified, any default_directory_policy role must be included to allow usage of the default acme directories under /pki/acme/directory and /pki/issuer/:issuer_id/acme/directory.
     * @type {Array<string>}
     * @memberof PkiConfigureAcmeRequest
     */
    allowedRoles?: Array<string>;
    /**
     * the policy to be used for non-role-qualified ACME requests; by default ACME issuance will be otherwise unrestricted, equivalent to the sign-verbatim endpoint; one may also specify a role to use as this policy, as "role:<role_name>", the specified role must be allowed by allowed_roles
     * @type {string}
     * @memberof PkiConfigureAcmeRequest
     */
    defaultDirectoryPolicy?: string;
    /**
     * DNS resolver to use for domain resolution on this mount. Defaults to using the default system resolver. Must be in the format <host>:<port>, with both parts mandatory.
     * @type {string}
     * @memberof PkiConfigureAcmeRequest
     */
    dnsResolver?: string;
    /**
     * Specify the policy to use for external account binding behaviour, 'not-required', 'new-account-required' or 'always-required'
     * @type {string}
     * @memberof PkiConfigureAcmeRequest
     */
    eabPolicy?: string;
    /**
     * whether ACME is enabled, defaults to false meaning that clusters will by default not get ACME support
     * @type {boolean}
     * @memberof PkiConfigureAcmeRequest
     */
    enabled?: boolean;
    /**
     * Specify the maximum TTL for ACME certificates. Role TTL values will be limited to this value
     * @type {string}
     * @memberof PkiConfigureAcmeRequest
     */
    maxTtl?: string;
}
/**
 * Check if a given object implements the PkiConfigureAcmeRequest interface.
 */
export declare function instanceOfPkiConfigureAcmeRequest(value: object): value is PkiConfigureAcmeRequest;
export declare function PkiConfigureAcmeRequestFromJSON(json: any): PkiConfigureAcmeRequest;
export declare function PkiConfigureAcmeRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): PkiConfigureAcmeRequest;
export declare function PkiConfigureAcmeRequestToJSON(json: any): PkiConfigureAcmeRequest;
export declare function PkiConfigureAcmeRequestToJSONTyped(value?: PkiConfigureAcmeRequest | null, ignoreDiscriminator?: boolean): any;
