/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface PkiConfigureScepRequest
 */
export interface PkiConfigureScepRequest {
    /**
     * the list of allowed digest algorithms for SCEP requests
     * @type {Array<string>}
     * @memberof PkiConfigureScepRequest
     */
    allowedDigestAlgorithms?: PkiConfigureScepRequestAllowedDigestAlgorithmsEnum;
    /**
     * the list of allowed encryption algorithms for SCEP requests
     * @type {Array<string>}
     * @memberof PkiConfigureScepRequest
     */
    allowedEncryptionAlgorithms?: PkiConfigureScepRequestAllowedEncryptionAlgorithmsEnum;
    /**
     * A map of authentication type to authentication parameters
     * @type {object}
     * @memberof PkiConfigureScepRequest
     */
    authenticators?: object;
    /**
     * the policy to be used for non-role-qualified SCEP requests; valid values are 'sign-verbatim', or "role:<role_name>" to specify a role to use as this policy.
     * @type {string}
     * @memberof PkiConfigureScepRequest
     */
    defaultPathPolicy?: string;
    /**
     * whether SCEP is enabled, defaults to false
     * @type {boolean}
     * @memberof PkiConfigureScepRequest
     */
    enabled?: boolean;
}
/**
* @export
* @enum {string}
*/
export declare enum PkiConfigureScepRequestAllowedDigestAlgorithmsEnum {
}
/**
* @export
* @enum {string}
*/
export declare enum PkiConfigureScepRequestAllowedEncryptionAlgorithmsEnum {
}
/**
 * Check if a given object implements the PkiConfigureScepRequest interface.
 */
export declare function instanceOfPkiConfigureScepRequest(value: object): value is PkiConfigureScepRequest;
export declare function PkiConfigureScepRequestFromJSON(json: any): PkiConfigureScepRequest;
export declare function PkiConfigureScepRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): PkiConfigureScepRequest;
export declare function PkiConfigureScepRequestToJSON(json: any): PkiConfigureScepRequest;
export declare function PkiConfigureScepRequestToJSONTyped(value?: PkiConfigureScepRequest | null, ignoreDiscriminator?: boolean): any;
