/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface PkiIssuerSignRevocationListRequest
 */
export interface PkiIssuerSignRevocationListRequest {
    /**
     * The sequence number to be written within the CRL Number extension.
     * @type {number}
     * @memberof PkiIssuerSignRevocationListRequest
     */
    crlNumber?: number;
    /**
     * Using a zero or greater value specifies the base CRL revision number to encode within a Delta CRL indicator extension, otherwise the extension will not be added.
     * @type {number}
     * @memberof PkiIssuerSignRevocationListRequest
     */
    deltaCrlBaseNumber?: number;
    /**
     * A list of maps containing extensions with keys id (string), critical (bool), value (string)
     * @type {Array<object>}
     * @memberof PkiIssuerSignRevocationListRequest
     */
    extensions?: Array<object>;
    /**
     * The format of the combined CRL, can be "pem" or "der". If "der", the value will be base64 encoded. Defaults to "pem".
     * @type {string}
     * @memberof PkiIssuerSignRevocationListRequest
     */
    format?: string;
    /**
     * The amount of time the generated CRL should be valid; defaults to 72 hours.
     * @type {string}
     * @memberof PkiIssuerSignRevocationListRequest
     */
    nextUpdate?: string;
    /**
     * A list of maps containing the keys serial_number (string), revocation_time (string), and extensions (map with keys id (string), critical (bool), value (string))
     * @type {Array<object>}
     * @memberof PkiIssuerSignRevocationListRequest
     */
    revokedCerts?: Array<object>;
}
/**
 * Check if a given object implements the PkiIssuerSignRevocationListRequest interface.
 */
export declare function instanceOfPkiIssuerSignRevocationListRequest(value: object): value is PkiIssuerSignRevocationListRequest;
export declare function PkiIssuerSignRevocationListRequestFromJSON(json: any): PkiIssuerSignRevocationListRequest;
export declare function PkiIssuerSignRevocationListRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): PkiIssuerSignRevocationListRequest;
export declare function PkiIssuerSignRevocationListRequestToJSON(json: any): PkiIssuerSignRevocationListRequest;
export declare function PkiIssuerSignRevocationListRequestToJSONTyped(value?: PkiIssuerSignRevocationListRequest | null, ignoreDiscriminator?: boolean): any;
