/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface PkiTidyCancelResponse
 */
export interface PkiTidyCancelResponse {
    /**
     * The number of revoked acme accounts removed
     * @type {number}
     * @memberof PkiTidyCancelResponse
     */
    acmeAccountDeletedCount?: number;
    /**
     * The number of unused acme accounts revoked
     * @type {number}
     * @memberof PkiTidyCancelResponse
     */
    acmeAccountRevokedCount?: number;
    /**
     * Safety buffer after creation after which accounts lacking orders are revoked
     * @type {number}
     * @memberof PkiTidyCancelResponse
     */
    acmeAccountSafetyBuffer?: number;
    /**
     * The number of expired, unused acme orders removed
     * @type {number}
     * @memberof PkiTidyCancelResponse
     */
    acmeOrdersDeletedCount?: number;
    /**
     * The number of metadata entries removed
     * @type {number}
     * @memberof PkiTidyCancelResponse
     */
    certMetadataDeletedCount?: number;
    /**
     * The number of certificate storage entries deleted
     * @type {number}
     * @memberof PkiTidyCancelResponse
     */
    certStoreDeletedCount?: number;
    /**
     * The number of CMPv2 nonces removed
     * @type {number}
     * @memberof PkiTidyCancelResponse
     */
    cmpv2NonceDeletedCount?: number;
    /**
     *
     * @type {number}
     * @memberof PkiTidyCancelResponse
     */
    crossRevokedCertDeletedCount?: number;
    /**
     * The number of revoked certificate entries deleted
     * @type {number}
     * @memberof PkiTidyCancelResponse
     */
    currentCertStoreCount?: number;
    /**
     * The number of revoked certificate entries deleted
     * @type {number}
     * @memberof PkiTidyCancelResponse
     */
    currentRevokedCertCount?: number;
    /**
     * The error message
     * @type {string}
     * @memberof PkiTidyCancelResponse
     */
    error?: string;
    /**
     *
     * @type {string}
     * @memberof PkiTidyCancelResponse
     */
    internalBackendUuid?: string;
    /**
     * Issuer safety buffer
     * @type {number}
     * @memberof PkiTidyCancelResponse
     */
    issuerSafetyBuffer?: number;
    /**
     * Time the last auto-tidy operation finished
     * @type {string}
     * @memberof PkiTidyCancelResponse
     */
    lastAutoTidyFinished?: string;
    /**
     * Message of the operation
     * @type {string}
     * @memberof PkiTidyCancelResponse
     */
    message?: string;
    /**
     *
     * @type {number}
     * @memberof PkiTidyCancelResponse
     */
    missingIssuerCertCount?: number;
    /**
     * Duration to pause between tidying certificates
     * @type {string}
     * @memberof PkiTidyCancelResponse
     */
    pauseDuration?: string;
    /**
     *
     * @type {number}
     * @memberof PkiTidyCancelResponse
     */
    revocationQueueDeletedCount?: number;
    /**
     * Revocation queue safety buffer
     * @type {number}
     * @memberof PkiTidyCancelResponse
     */
    revocationQueueSafetyBuffer?: number;
    /**
     * The number of revoked certificate entries deleted
     * @type {number}
     * @memberof PkiTidyCancelResponse
     */
    revokedCertDeletedCount?: number;
    /**
     * Safety buffer time duration
     * @type {number}
     * @memberof PkiTidyCancelResponse
     */
    safetyBuffer?: number;
    /**
     * One of Inactive, Running, Finished, or Error
     * @type {string}
     * @memberof PkiTidyCancelResponse
     */
    state?: string;
    /**
     * Tidy Unused Acme Accounts, and Orders
     * @type {boolean}
     * @memberof PkiTidyCancelResponse
     */
    tidyAcme?: boolean;
    /**
     * Tidy cert metadata
     * @type {boolean}
     * @memberof PkiTidyCancelResponse
     */
    tidyCertMetadata?: boolean;
    /**
     * Tidy certificate store
     * @type {boolean}
     * @memberof PkiTidyCancelResponse
     */
    tidyCertStore?: boolean;
    /**
     * Tidy CMPv2 nonce store
     * @type {boolean}
     * @memberof PkiTidyCancelResponse
     */
    tidyCmpv2NonceStore?: boolean;
    /**
     * Tidy the cross-cluster revoked certificate store
     * @type {boolean}
     * @memberof PkiTidyCancelResponse
     */
    tidyCrossClusterRevokedCerts?: boolean;
    /**
     * Tidy expired issuers
     * @type {boolean}
     * @memberof PkiTidyCancelResponse
     */
    tidyExpiredIssuers?: boolean;
    /**
     *
     * @type {boolean}
     * @memberof PkiTidyCancelResponse
     */
    tidyMoveLegacyCaBundle?: boolean;
    /**
     *
     * @type {boolean}
     * @memberof PkiTidyCancelResponse
     */
    tidyRevocationQueue?: boolean;
    /**
     * Tidy revoked certificate issuer associations
     * @type {boolean}
     * @memberof PkiTidyCancelResponse
     */
    tidyRevokedCertIssuerAssociations?: boolean;
    /**
     * Tidy revoked certificates
     * @type {boolean}
     * @memberof PkiTidyCancelResponse
     */
    tidyRevokedCerts?: boolean;
    /**
     * Time the operation finished
     * @type {string}
     * @memberof PkiTidyCancelResponse
     */
    timeFinished?: string;
    /**
     * Time the operation started
     * @type {string}
     * @memberof PkiTidyCancelResponse
     */
    timeStarted?: string;
    /**
     * Total number of acme accounts iterated over
     * @type {number}
     * @memberof PkiTidyCancelResponse
     */
    totalAcmeAccountCount?: number;
}
/**
 * Check if a given object implements the PkiTidyCancelResponse interface.
 */
export declare function instanceOfPkiTidyCancelResponse(value: object): value is PkiTidyCancelResponse;
export declare function PkiTidyCancelResponseFromJSON(json: any): PkiTidyCancelResponse;
export declare function PkiTidyCancelResponseFromJSONTyped(json: any, ignoreDiscriminator: boolean): PkiTidyCancelResponse;
export declare function PkiTidyCancelResponseToJSON(json: any): PkiTidyCancelResponse;
export declare function PkiTidyCancelResponseToJSONTyped(value?: PkiTidyCancelResponse | null, ignoreDiscriminator?: boolean): any;
