/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface SystemPatchSyncDestinationsInMemNameRequest
 */
export interface SystemPatchSyncDestinationsInMemNameRequest {
    /**
     * Sets which IPv4 addresses Vault is allowed to connect to for syncing secrets.
     * @type {Array<string>}
     * @memberof SystemPatchSyncDestinationsInMemNameRequest
     */
    allowedIpv4Addresses?: Array<string>;
    /**
     * Sets which IPv6 addresses Vault is allowed to connect to for syncing secrets.
     * @type {Array<string>}
     * @memberof SystemPatchSyncDestinationsInMemNameRequest
     */
    allowedIpv6Addresses?: Array<string>;
    /**
     * Sets which port numbers Vault is allowed to connect through for syncing secrets.
     * @type {Array<string>}
     * @memberof SystemPatchSyncDestinationsInMemNameRequest
     */
    allowedPorts?: Array<string>;
    /**
     * Allows all IP addresses and ports to be connected to for syncing secrets.
     * @type {boolean}
     * @memberof SystemPatchSyncDestinationsInMemNameRequest
     */
    disableStrictNetworking?: boolean;
    /**
     * Determines what level of information is synced as a distinct resource at the destination. Supports `secret-path` and `secret-key`.
     * @type {string}
     * @memberof SystemPatchSyncDestinationsInMemNameRequest
     */
    granularity?: string;
    /**
     * Asynchronously unsyncs all associated secrets with the destination then deletes the destination config.
     * @type {boolean}
     * @memberof SystemPatchSyncDestinationsInMemNameRequest
     */
    purge?: boolean;
    /**
     * Template describing how to generate external secret names. Supports a subset of the Go Template syntax.
     * @type {string}
     * @memberof SystemPatchSyncDestinationsInMemNameRequest
     */
    secretNameTemplate?: string;
}
/**
 * Check if a given object implements the SystemPatchSyncDestinationsInMemNameRequest interface.
 */
export declare function instanceOfSystemPatchSyncDestinationsInMemNameRequest(value: object): value is SystemPatchSyncDestinationsInMemNameRequest;
export declare function SystemPatchSyncDestinationsInMemNameRequestFromJSON(json: any): SystemPatchSyncDestinationsInMemNameRequest;
export declare function SystemPatchSyncDestinationsInMemNameRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): SystemPatchSyncDestinationsInMemNameRequest;
export declare function SystemPatchSyncDestinationsInMemNameRequestToJSON(json: any): SystemPatchSyncDestinationsInMemNameRequest;
export declare function SystemPatchSyncDestinationsInMemNameRequestToJSONTyped(value?: SystemPatchSyncDestinationsInMemNameRequest | null, ignoreDiscriminator?: boolean): any;
