/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface SystemWriteReplicationDrSecondaryUpdatePrimaryRequest
 */
export interface SystemWriteReplicationDrSecondaryUpdatePrimaryRequest {
    /**
     * A path to a file containing a PEM-encoded CA certificate to verify the call against the primary's API address
     * @type {string}
     * @memberof SystemWriteReplicationDrSecondaryUpdatePrimaryRequest
     */
    caFile?: string;
    /**
     * A path to a directory containing PEM-encoded CA certificates to verify the call against the primary's API address
     * @type {string}
     * @memberof SystemWriteReplicationDrSecondaryUpdatePrimaryRequest
     */
    caPath?: string;
    /**
     * The client certificate to use for authentication, in PEM format. Note: client authentication for this operation will always use TLS 1.2 or higher.
     * @type {string}
     * @memberof SystemWriteReplicationDrSecondaryUpdatePrimaryRequest
     */
    clientCertPem?: string;
    /**
     * The client key to use for authentication, in PEM format.
     * @type {string}
     * @memberof SystemWriteReplicationDrSecondaryUpdatePrimaryRequest
     */
    clientKeyPem?: string;
    /**
     * DR operation token used to authorize this request.
     * @type {string}
     * @memberof SystemWriteReplicationDrSecondaryUpdatePrimaryRequest
     */
    drOperationToken?: string;
    /**
     * The API address of the primary. If not set, the value the primary supplies in the token will be used, which is the primary's redirect address.
     * @type {string}
     * @memberof SystemWriteReplicationDrSecondaryUpdatePrimaryRequest
     */
    primaryApiAddr?: string;
    /**
     * The token given by the primary to activate secondary status for this cluster.
     * @type {string}
     * @memberof SystemWriteReplicationDrSecondaryUpdatePrimaryRequest
     */
    token?: string;
    /**
     * A comma separated list of host:port strings to serve as new addresses for the primary cluster
     * @type {Array<string>}
     * @memberof SystemWriteReplicationDrSecondaryUpdatePrimaryRequest
     */
    updatePrimaryAddrs?: Array<string>;
}
/**
 * Check if a given object implements the SystemWriteReplicationDrSecondaryUpdatePrimaryRequest interface.
 */
export declare function instanceOfSystemWriteReplicationDrSecondaryUpdatePrimaryRequest(value: object): value is SystemWriteReplicationDrSecondaryUpdatePrimaryRequest;
export declare function SystemWriteReplicationDrSecondaryUpdatePrimaryRequestFromJSON(json: any): SystemWriteReplicationDrSecondaryUpdatePrimaryRequest;
export declare function SystemWriteReplicationDrSecondaryUpdatePrimaryRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): SystemWriteReplicationDrSecondaryUpdatePrimaryRequest;
export declare function SystemWriteReplicationDrSecondaryUpdatePrimaryRequestToJSON(json: any): SystemWriteReplicationDrSecondaryUpdatePrimaryRequest;
export declare function SystemWriteReplicationDrSecondaryUpdatePrimaryRequestToJSONTyped(value?: SystemWriteReplicationDrSecondaryUpdatePrimaryRequest | null, ignoreDiscriminator?: boolean): any;
