/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface TransitGenerateCmacWithMacLengthRequest
 */
export interface TransitGenerateCmacWithMacLengthRequest {
    /**
     * Specifies a list of items to be processed in a single batch. When this parameter is set, if the parameter 'input' is also set, it will be ignored. Any batch output will preserve the order of the batch input.
     * @type {Array<object>}
     * @memberof TransitGenerateCmacWithMacLengthRequest
     */
    batchInput?: Array<object>;
    /**
     * The base64-encoded input data
     * @type {string}
     * @memberof TransitGenerateCmacWithMacLengthRequest
     */
    input?: string;
    /**
     * The version of the key to use for generating the CMAC. Must be 0 (for latest) or a value greater than or equal to the min_encryption_version configured on the key.
     * @type {number}
     * @memberof TransitGenerateCmacWithMacLengthRequest
     */
    keyVersion?: number;
    /**
     * MAC length to use (POST body parameter). Valid values are:
     * @type {number}
     * @memberof TransitGenerateCmacWithMacLengthRequest
     */
    macLength?: number;
}
/**
 * Check if a given object implements the TransitGenerateCmacWithMacLengthRequest interface.
 */
export declare function instanceOfTransitGenerateCmacWithMacLengthRequest(value: object): value is TransitGenerateCmacWithMacLengthRequest;
export declare function TransitGenerateCmacWithMacLengthRequestFromJSON(json: any): TransitGenerateCmacWithMacLengthRequest;
export declare function TransitGenerateCmacWithMacLengthRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): TransitGenerateCmacWithMacLengthRequest;
export declare function TransitGenerateCmacWithMacLengthRequestToJSON(json: any): TransitGenerateCmacWithMacLengthRequest;
export declare function TransitGenerateCmacWithMacLengthRequestToJSONTyped(value?: TransitGenerateCmacWithMacLengthRequest | null, ignoreDiscriminator?: boolean): any;
