/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface AwsConfigureClientRequest
 */
export interface AwsConfigureClientRequest {
    /**
     * AWS Access Key ID for the account used to make AWS API requests.
     * @type {string}
     * @memberof AwsConfigureClientRequest
     */
    accessKey?: string;
    /**
     * List of additional headers that are allowed to be in AWS STS request headers
     * @type {Array<string>}
     * @memberof AwsConfigureClientRequest
     */
    allowedStsHeaderValues?: Array<string>;
    /**
     * If set to true, will deregister all registered rotation jobs from the RotationManager for the plugin.
     * @type {boolean}
     * @memberof AwsConfigureClientRequest
     */
    disableAutomatedRotation?: boolean;
    /**
     * URL to override the default generated endpoint for making AWS EC2 API calls.
     * @type {string}
     * @memberof AwsConfigureClientRequest
     */
    endpoint?: string;
    /**
     * URL to override the default generated endpoint for making AWS IAM API calls.
     * @type {string}
     * @memberof AwsConfigureClientRequest
     */
    iamEndpoint?: string;
    /**
     * Value to require in the X-Vault-AWS-IAM-Server-ID request header
     * @type {string}
     * @memberof AwsConfigureClientRequest
     */
    iamServerIdHeaderValue?: string;
    /**
     * Audience of plugin identity tokens
     * @type {string}
     * @memberof AwsConfigureClientRequest
     */
    identityTokenAudience?: string;
    /**
     * Time-to-live of plugin identity tokens
     * @type {string}
     * @memberof AwsConfigureClientRequest
     */
    identityTokenTtl?: string;
    /**
     * Maximum number of retries for recoverable exceptions of AWS APIs
     * @type {number}
     * @memberof AwsConfigureClientRequest
     */
    maxRetries?: number;
    /**
     * Role ARN to assume for plugin identity token federation
     * @type {string}
     * @memberof AwsConfigureClientRequest
     */
    roleArn?: string;
    /**
     * TTL for automatic credential rotation of the given username. Mutually exclusive with rotation_schedule
     * @type {string}
     * @memberof AwsConfigureClientRequest
     */
    rotationPeriod?: string;
    /**
     * CRON-style string that will define the schedule on which rotations should occur. Mutually exclusive with rotation_period
     * @type {string}
     * @memberof AwsConfigureClientRequest
     */
    rotationSchedule?: string;
    /**
     * Specifies the amount of time in which the rotation is allowed to occur starting from a given rotation_schedule
     * @type {string}
     * @memberof AwsConfigureClientRequest
     */
    rotationWindow?: string;
    /**
     * AWS Secret Access Key for the account used to make AWS API requests.
     * @type {string}
     * @memberof AwsConfigureClientRequest
     */
    secretKey?: string;
    /**
     * URL to override the default generated endpoint for making AWS STS API calls.
     * @type {string}
     * @memberof AwsConfigureClientRequest
     */
    stsEndpoint?: string;
    /**
     * The region ID for the sts_endpoint, if set.
     * @type {string}
     * @memberof AwsConfigureClientRequest
     */
    stsRegion?: string;
    /**
     * Uses the STS region from client requests for making AWS STS API calls.
     * @type {boolean}
     * @memberof AwsConfigureClientRequest
     */
    useStsRegionFromClient?: boolean;
}

/**
 * Check if a given object implements the AwsConfigureClientRequest interface.
 */
export function instanceOfAwsConfigureClientRequest(value: object): value is AwsConfigureClientRequest {
    return true;
}

export function AwsConfigureClientRequestFromJSON(json: any): AwsConfigureClientRequest {
    return AwsConfigureClientRequestFromJSONTyped(json, false);
}

export function AwsConfigureClientRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): AwsConfigureClientRequest {
    if (json == null) {
        return json;
    }
    return {
        
        'accessKey': json['access_key'] == null ? undefined : json['access_key'],
        'allowedStsHeaderValues': json['allowed_sts_header_values'] == null ? undefined : json['allowed_sts_header_values'],
        'disableAutomatedRotation': json['disable_automated_rotation'] == null ? undefined : json['disable_automated_rotation'],
        'endpoint': json['endpoint'] == null ? undefined : json['endpoint'],
        'iamEndpoint': json['iam_endpoint'] == null ? undefined : json['iam_endpoint'],
        'iamServerIdHeaderValue': json['iam_server_id_header_value'] == null ? undefined : json['iam_server_id_header_value'],
        'identityTokenAudience': json['identity_token_audience'] == null ? undefined : json['identity_token_audience'],
        'identityTokenTtl': json['identity_token_ttl'] == null ? undefined : json['identity_token_ttl'],
        'maxRetries': json['max_retries'] == null ? undefined : json['max_retries'],
        'roleArn': json['role_arn'] == null ? undefined : json['role_arn'],
        'rotationPeriod': json['rotation_period'] == null ? undefined : json['rotation_period'],
        'rotationSchedule': json['rotation_schedule'] == null ? undefined : json['rotation_schedule'],
        'rotationWindow': json['rotation_window'] == null ? undefined : json['rotation_window'],
        'secretKey': json['secret_key'] == null ? undefined : json['secret_key'],
        'stsEndpoint': json['sts_endpoint'] == null ? undefined : json['sts_endpoint'],
        'stsRegion': json['sts_region'] == null ? undefined : json['sts_region'],
        'useStsRegionFromClient': json['use_sts_region_from_client'] == null ? undefined : json['use_sts_region_from_client'],
    };
}

export function AwsConfigureClientRequestToJSON(json: any): AwsConfigureClientRequest {
    return AwsConfigureClientRequestToJSONTyped(json, false);
}

export function AwsConfigureClientRequestToJSONTyped(value?: AwsConfigureClientRequest | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
        'access_key': value['accessKey'],
        'allowed_sts_header_values': value['allowedStsHeaderValues'],
        'disable_automated_rotation': value['disableAutomatedRotation'],
        'endpoint': value['endpoint'],
        'iam_endpoint': value['iamEndpoint'],
        'iam_server_id_header_value': value['iamServerIdHeaderValue'],
        'identity_token_audience': value['identityTokenAudience'],
        'identity_token_ttl': value['identityTokenTtl'],
        'max_retries': value['maxRetries'],
        'role_arn': value['roleArn'],
        'rotation_period': value['rotationPeriod'],
        'rotation_schedule': value['rotationSchedule'],
        'rotation_window': value['rotationWindow'],
        'secret_key': value['secretKey'],
        'sts_endpoint': value['stsEndpoint'],
        'sts_region': value['stsRegion'],
        'use_sts_region_from_client': value['useStsRegionFromClient'],
    };
}

