/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface AwsConfigureRootIamCredentialsRequest
 */
export interface AwsConfigureRootIamCredentialsRequest {
    /**
     * Access key with permission to create new keys.
     * @type {string}
     * @memberof AwsConfigureRootIamCredentialsRequest
     */
    accessKey?: string;
    /**
     * If set to true, will deregister all registered rotation jobs from the RotationManager for the plugin.
     * @type {boolean}
     * @memberof AwsConfigureRootIamCredentialsRequest
     */
    disableAutomatedRotation?: boolean;
    /**
     * Endpoint to custom IAM server URL
     * @type {string}
     * @memberof AwsConfigureRootIamCredentialsRequest
     */
    iamEndpoint?: string;
    /**
     * Audience of plugin identity tokens
     * @type {string}
     * @memberof AwsConfigureRootIamCredentialsRequest
     */
    identityTokenAudience?: string;
    /**
     * Time-to-live of plugin identity tokens
     * @type {string}
     * @memberof AwsConfigureRootIamCredentialsRequest
     */
    identityTokenTtl?: string;
    /**
     * Maximum number of retries for recoverable exceptions of AWS APIs
     * @type {number}
     * @memberof AwsConfigureRootIamCredentialsRequest
     */
    maxRetries?: number;
    /**
     * Region for API calls.
     * @type {string}
     * @memberof AwsConfigureRootIamCredentialsRequest
     */
    region?: string;
    /**
     * Role ARN to assume for plugin identity token federation
     * @type {string}
     * @memberof AwsConfigureRootIamCredentialsRequest
     */
    roleArn?: string;
    /**
     * TTL for automatic credential rotation of the given username. Mutually exclusive with rotation_schedule
     * @type {string}
     * @memberof AwsConfigureRootIamCredentialsRequest
     */
    rotationPeriod?: string;
    /**
     * CRON-style string that will define the schedule on which rotations should occur. Mutually exclusive with rotation_period
     * @type {string}
     * @memberof AwsConfigureRootIamCredentialsRequest
     */
    rotationSchedule?: string;
    /**
     * Specifies the amount of time in which the rotation is allowed to occur starting from a given rotation_schedule
     * @type {string}
     * @memberof AwsConfigureRootIamCredentialsRequest
     */
    rotationWindow?: string;
    /**
     * Secret key with permission to create new keys.
     * @type {string}
     * @memberof AwsConfigureRootIamCredentialsRequest
     */
    secretKey?: string;
    /**
     * Endpoint to custom STS server URL
     * @type {string}
     * @memberof AwsConfigureRootIamCredentialsRequest
     */
    stsEndpoint?: string;
    /**
     * Fallback endpoints if sts_endpoint is unreachable
     * @type {Array<string>}
     * @memberof AwsConfigureRootIamCredentialsRequest
     */
    stsFallbackEndpoints?: Array<string>;
    /**
     * Fallback regions if sts_region is unreachable
     * @type {Array<string>}
     * @memberof AwsConfigureRootIamCredentialsRequest
     */
    stsFallbackRegions?: Array<string>;
    /**
     * Specific region for STS API calls.
     * @type {string}
     * @memberof AwsConfigureRootIamCredentialsRequest
     */
    stsRegion?: string;
    /**
     * Template to generate custom IAM usernames
     * @type {string}
     * @memberof AwsConfigureRootIamCredentialsRequest
     */
    usernameTemplate?: string;
}

/**
 * Check if a given object implements the AwsConfigureRootIamCredentialsRequest interface.
 */
export function instanceOfAwsConfigureRootIamCredentialsRequest(value: object): value is AwsConfigureRootIamCredentialsRequest {
    return true;
}

export function AwsConfigureRootIamCredentialsRequestFromJSON(json: any): AwsConfigureRootIamCredentialsRequest {
    return AwsConfigureRootIamCredentialsRequestFromJSONTyped(json, false);
}

export function AwsConfigureRootIamCredentialsRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): AwsConfigureRootIamCredentialsRequest {
    if (json == null) {
        return json;
    }
    return {
        
        'accessKey': json['access_key'] == null ? undefined : json['access_key'],
        'disableAutomatedRotation': json['disable_automated_rotation'] == null ? undefined : json['disable_automated_rotation'],
        'iamEndpoint': json['iam_endpoint'] == null ? undefined : json['iam_endpoint'],
        'identityTokenAudience': json['identity_token_audience'] == null ? undefined : json['identity_token_audience'],
        'identityTokenTtl': json['identity_token_ttl'] == null ? undefined : json['identity_token_ttl'],
        'maxRetries': json['max_retries'] == null ? undefined : json['max_retries'],
        'region': json['region'] == null ? undefined : json['region'],
        'roleArn': json['role_arn'] == null ? undefined : json['role_arn'],
        'rotationPeriod': json['rotation_period'] == null ? undefined : json['rotation_period'],
        'rotationSchedule': json['rotation_schedule'] == null ? undefined : json['rotation_schedule'],
        'rotationWindow': json['rotation_window'] == null ? undefined : json['rotation_window'],
        'secretKey': json['secret_key'] == null ? undefined : json['secret_key'],
        'stsEndpoint': json['sts_endpoint'] == null ? undefined : json['sts_endpoint'],
        'stsFallbackEndpoints': json['sts_fallback_endpoints'] == null ? undefined : json['sts_fallback_endpoints'],
        'stsFallbackRegions': json['sts_fallback_regions'] == null ? undefined : json['sts_fallback_regions'],
        'stsRegion': json['sts_region'] == null ? undefined : json['sts_region'],
        'usernameTemplate': json['username_template'] == null ? undefined : json['username_template'],
    };
}

export function AwsConfigureRootIamCredentialsRequestToJSON(json: any): AwsConfigureRootIamCredentialsRequest {
    return AwsConfigureRootIamCredentialsRequestToJSONTyped(json, false);
}

export function AwsConfigureRootIamCredentialsRequestToJSONTyped(value?: AwsConfigureRootIamCredentialsRequest | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
        'access_key': value['accessKey'],
        'disable_automated_rotation': value['disableAutomatedRotation'],
        'iam_endpoint': value['iamEndpoint'],
        'identity_token_audience': value['identityTokenAudience'],
        'identity_token_ttl': value['identityTokenTtl'],
        'max_retries': value['maxRetries'],
        'region': value['region'],
        'role_arn': value['roleArn'],
        'rotation_period': value['rotationPeriod'],
        'rotation_schedule': value['rotationSchedule'],
        'rotation_window': value['rotationWindow'],
        'secret_key': value['secretKey'],
        'sts_endpoint': value['stsEndpoint'],
        'sts_fallback_endpoints': value['stsFallbackEndpoints'],
        'sts_fallback_regions': value['stsFallbackRegions'],
        'sts_region': value['stsRegion'],
        'username_template': value['usernameTemplate'],
    };
}

