/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface DatabaseWriteStaticRoleRequest
 */
export interface DatabaseWriteStaticRoleRequest {
    /**
     * The configuration for the given credential_type.
     * @type {object}
     * @memberof DatabaseWriteStaticRoleRequest
     */
    credentialConfig?: object;
    /**
     * The type of credential to manage. Options include: 'password', 'rsa_private_key'. Defaults to 'password'.
     * @type {string}
     * @memberof DatabaseWriteStaticRoleRequest
     */
    credentialType?: string;
    /**
     * Name of the database this role acts on.
     * @type {string}
     * @memberof DatabaseWriteStaticRoleRequest
     */
    dbName?: string;
    /**
     * Enterprise only. If set, the initial static account password of the external db user before the first Vault rotatation.
     * @type {string}
     * @memberof DatabaseWriteStaticRoleRequest
     */
    password?: string;
    /**
     * Period for automatic credential rotation of the given username. Not valid unless used with "username". Mutually exclusive with "rotation_schedule."
     * @type {string}
     * @memberof DatabaseWriteStaticRoleRequest
     */
    rotationPeriod?: string;
    /**
     * Schedule for automatic credential rotation of the given username. Mutually exclusive with "rotation_period."
     * @type {string}
     * @memberof DatabaseWriteStaticRoleRequest
     */
    rotationSchedule?: string;
    /**
     * Specifies the database statements to be executed to rotate the accounts credentials. Not every plugin type will support this functionality. See the plugin's API page for more information on support and formatting for this parameter.
     * @type {Array<string>}
     * @memberof DatabaseWriteStaticRoleRequest
     */
    rotationStatements?: Array<string>;
    /**
     * The window of time in which rotations are allowed to occur starting from a given "rotation_schedule". Requires "rotation_schedule" to be specified
     * @type {string}
     * @memberof DatabaseWriteStaticRoleRequest
     */
    rotationWindow?: string;
    /**
     * Used to connect to a self-managed static account. Must be provided by the user when root credentials are not provided.
     * @type {string}
     * @memberof DatabaseWriteStaticRoleRequest
     * @deprecated
     */
    selfManagedPassword?: string;
    /**
     * Enterprise only. If true, the static account password will not be rotated on creation of the role. Defaults to false.
     * @type {boolean}
     * @memberof DatabaseWriteStaticRoleRequest
     */
    skipImportRotation?: boolean;
    /**
     * Name of the static user account for Vault to manage. Requires "rotation_period" to be specified
     * @type {string}
     * @memberof DatabaseWriteStaticRoleRequest
     */
    username?: string;
}

/**
 * Check if a given object implements the DatabaseWriteStaticRoleRequest interface.
 */
export function instanceOfDatabaseWriteStaticRoleRequest(value: object): value is DatabaseWriteStaticRoleRequest {
    return true;
}

export function DatabaseWriteStaticRoleRequestFromJSON(json: any): DatabaseWriteStaticRoleRequest {
    return DatabaseWriteStaticRoleRequestFromJSONTyped(json, false);
}

export function DatabaseWriteStaticRoleRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): DatabaseWriteStaticRoleRequest {
    if (json == null) {
        return json;
    }
    return {
        
        'credentialConfig': json['credential_config'] == null ? undefined : json['credential_config'],
        'credentialType': json['credential_type'] == null ? undefined : json['credential_type'],
        'dbName': json['db_name'] == null ? undefined : json['db_name'],
        'password': json['password'] == null ? undefined : json['password'],
        'rotationPeriod': json['rotation_period'] == null ? undefined : json['rotation_period'],
        'rotationSchedule': json['rotation_schedule'] == null ? undefined : json['rotation_schedule'],
        'rotationStatements': json['rotation_statements'] == null ? undefined : json['rotation_statements'],
        'rotationWindow': json['rotation_window'] == null ? undefined : json['rotation_window'],
        'selfManagedPassword': json['self_managed_password'] == null ? undefined : json['self_managed_password'],
        'skipImportRotation': json['skip_import_rotation'] == null ? undefined : json['skip_import_rotation'],
        'username': json['username'] == null ? undefined : json['username'],
    };
}

export function DatabaseWriteStaticRoleRequestToJSON(json: any): DatabaseWriteStaticRoleRequest {
    return DatabaseWriteStaticRoleRequestToJSONTyped(json, false);
}

export function DatabaseWriteStaticRoleRequestToJSONTyped(value?: DatabaseWriteStaticRoleRequest | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
        'credential_config': value['credentialConfig'],
        'credential_type': value['credentialType'],
        'db_name': value['dbName'],
        'password': value['password'],
        'rotation_period': value['rotationPeriod'],
        'rotation_schedule': value['rotationSchedule'],
        'rotation_statements': value['rotationStatements'],
        'rotation_window': value['rotationWindow'],
        'self_managed_password': value['selfManagedPassword'],
        'skip_import_rotation': value['skipImportRotation'],
        'username': value['username'],
    };
}

