/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface GoogleCloudConfigureAuthRequest
 */
export interface GoogleCloudConfigureAuthRequest {
    /**
     * Google credentials JSON that Vault will use to verify users against GCP APIs. If not specified, will use application default credentials
     * @type {string}
     * @memberof GoogleCloudConfigureAuthRequest
     */
    credentials?: string;
    /**
     * Specifies overrides for various Google API Service Endpoints used in requests.
     * @type {object}
     * @memberof GoogleCloudConfigureAuthRequest
     */
    customEndpoint?: object;
    /**
     * If set to true, will deregister all registered rotation jobs from the RotationManager for the plugin.
     * @type {boolean}
     * @memberof GoogleCloudConfigureAuthRequest
     */
    disableAutomatedRotation?: boolean;
    /**
     * Indicates what value to use when generating an alias for GCE authentications.
     * @type {string}
     * @memberof GoogleCloudConfigureAuthRequest
     */
    gceAlias?: string;
    /**
     * The metadata to include on the aliases and audit logs generated by this plugin. When set to 'default', includes: instance_creation_timestamp, instance_id, instance_name, project_id, project_number, role, service_account_id, service_account_email, zone. Not editing this field means the 'default' fields are included. Explicitly setting this field to empty overrides the 'default' and means no metadata will be included. If not using 'default', explicit fields must be sent like: 'field1,field2'.
     * @type {Array<string>}
     * @memberof GoogleCloudConfigureAuthRequest
     */
    gceMetadata?: Array<string>;
    /**
     * Deprecated. This field does nothing and be removed in a future release
     * @type {string}
     * @memberof GoogleCloudConfigureAuthRequest
     * @deprecated
     */
    googleCertsEndpoint?: string;
    /**
     * Indicates what value to use when generating an alias for IAM authentications.
     * @type {string}
     * @memberof GoogleCloudConfigureAuthRequest
     */
    iamAlias?: string;
    /**
     * The metadata to include on the aliases and audit logs generated by this plugin. When set to 'default', includes: project_id, role, service_account_id, service_account_email. Not editing this field means the 'default' fields are included. Explicitly setting this field to empty overrides the 'default' and means no metadata will be included. If not using 'default', explicit fields must be sent like: 'field1,field2'.
     * @type {Array<string>}
     * @memberof GoogleCloudConfigureAuthRequest
     */
    iamMetadata?: Array<string>;
    /**
     * Audience of plugin identity tokens
     * @type {string}
     * @memberof GoogleCloudConfigureAuthRequest
     */
    identityTokenAudience?: string;
    /**
     * Time-to-live of plugin identity tokens
     * @type {string}
     * @memberof GoogleCloudConfigureAuthRequest
     */
    identityTokenTtl?: string;
    /**
     * TTL for automatic credential rotation of the given username. Mutually exclusive with rotation_schedule
     * @type {string}
     * @memberof GoogleCloudConfigureAuthRequest
     */
    rotationPeriod?: string;
    /**
     * CRON-style string that will define the schedule on which rotations should occur. Mutually exclusive with rotation_period
     * @type {string}
     * @memberof GoogleCloudConfigureAuthRequest
     */
    rotationSchedule?: string;
    /**
     * Specifies the amount of time in which the rotation is allowed to occur starting from a given rotation_schedule
     * @type {string}
     * @memberof GoogleCloudConfigureAuthRequest
     */
    rotationWindow?: string;
    /**
     * Email ID for the Service Account to impersonate for Workload Identity Federation.
     * @type {string}
     * @memberof GoogleCloudConfigureAuthRequest
     */
    serviceAccountEmail?: string;
}

/**
 * Check if a given object implements the GoogleCloudConfigureAuthRequest interface.
 */
export function instanceOfGoogleCloudConfigureAuthRequest(value: object): value is GoogleCloudConfigureAuthRequest {
    return true;
}

export function GoogleCloudConfigureAuthRequestFromJSON(json: any): GoogleCloudConfigureAuthRequest {
    return GoogleCloudConfigureAuthRequestFromJSONTyped(json, false);
}

export function GoogleCloudConfigureAuthRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): GoogleCloudConfigureAuthRequest {
    if (json == null) {
        return json;
    }
    return {
        
        'credentials': json['credentials'] == null ? undefined : json['credentials'],
        'customEndpoint': json['custom_endpoint'] == null ? undefined : json['custom_endpoint'],
        'disableAutomatedRotation': json['disable_automated_rotation'] == null ? undefined : json['disable_automated_rotation'],
        'gceAlias': json['gce_alias'] == null ? undefined : json['gce_alias'],
        'gceMetadata': json['gce_metadata'] == null ? undefined : json['gce_metadata'],
        'googleCertsEndpoint': json['google_certs_endpoint'] == null ? undefined : json['google_certs_endpoint'],
        'iamAlias': json['iam_alias'] == null ? undefined : json['iam_alias'],
        'iamMetadata': json['iam_metadata'] == null ? undefined : json['iam_metadata'],
        'identityTokenAudience': json['identity_token_audience'] == null ? undefined : json['identity_token_audience'],
        'identityTokenTtl': json['identity_token_ttl'] == null ? undefined : json['identity_token_ttl'],
        'rotationPeriod': json['rotation_period'] == null ? undefined : json['rotation_period'],
        'rotationSchedule': json['rotation_schedule'] == null ? undefined : json['rotation_schedule'],
        'rotationWindow': json['rotation_window'] == null ? undefined : json['rotation_window'],
        'serviceAccountEmail': json['service_account_email'] == null ? undefined : json['service_account_email'],
    };
}

export function GoogleCloudConfigureAuthRequestToJSON(json: any): GoogleCloudConfigureAuthRequest {
    return GoogleCloudConfigureAuthRequestToJSONTyped(json, false);
}

export function GoogleCloudConfigureAuthRequestToJSONTyped(value?: GoogleCloudConfigureAuthRequest | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
        'credentials': value['credentials'],
        'custom_endpoint': value['customEndpoint'],
        'disable_automated_rotation': value['disableAutomatedRotation'],
        'gce_alias': value['gceAlias'],
        'gce_metadata': value['gceMetadata'],
        'google_certs_endpoint': value['googleCertsEndpoint'],
        'iam_alias': value['iamAlias'],
        'iam_metadata': value['iamMetadata'],
        'identity_token_audience': value['identityTokenAudience'],
        'identity_token_ttl': value['identityTokenTtl'],
        'rotation_period': value['rotationPeriod'],
        'rotation_schedule': value['rotationSchedule'],
        'rotation_window': value['rotationWindow'],
        'service_account_email': value['serviceAccountEmail'],
    };
}

