/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface GroupsCreateDuplicatesRequest
 */
export interface GroupsCreateDuplicatesRequest {
    /**
     * Number of groups to create
     * @type {number}
     * @memberof GroupsCreateDuplicatesRequest
     */
    count?: number;
    /**
     * Create entities with different case variations
     * @type {boolean}
     * @memberof GroupsCreateDuplicatesRequest
     */
    differentCase?: boolean;
    /**
     * ID of the group. If set, updates the corresponding existing group.
     * @type {string}
     * @memberof GroupsCreateDuplicatesRequest
     */
    id?: string;
    /**
     * Entity IDs to be assigned as group members.
     * @type {Array<string>}
     * @memberof GroupsCreateDuplicatesRequest
     */
    memberEntityIds?: Array<string>;
    /**
     * Group IDs to be assigned as group members.
     * @type {Array<string>}
     * @memberof GroupsCreateDuplicatesRequest
     */
    memberGroupIds?: Array<string>;
    /**
     * Metadata to be associated with the group. In CLI, this parameter can be repeated multiple times, and it all gets merged together. For example: vault <command> <path> metadata=key1=value1 metadata=key2=value2
     * @type {object}
     * @memberof GroupsCreateDuplicatesRequest
     */
    metadata?: object;
    /**
     * Name of the group.
     * @type {string}
     * @memberof GroupsCreateDuplicatesRequest
     */
    name?: string;
    /**
     * NamespaceID of the entities to create
     * @type {string}
     * @memberof GroupsCreateDuplicatesRequest
     */
    namespaceId?: string;
    /**
     * Policies to be tied to the group.
     * @type {Array<string>}
     * @memberof GroupsCreateDuplicatesRequest
     */
    policies?: Array<string>;
    /**
     * Type of the group, 'internal' or 'external'. Defaults to 'internal'
     * @type {string}
     * @memberof GroupsCreateDuplicatesRequest
     */
    type?: string;
}

/**
 * Check if a given object implements the GroupsCreateDuplicatesRequest interface.
 */
export function instanceOfGroupsCreateDuplicatesRequest(value: object): value is GroupsCreateDuplicatesRequest {
    return true;
}

export function GroupsCreateDuplicatesRequestFromJSON(json: any): GroupsCreateDuplicatesRequest {
    return GroupsCreateDuplicatesRequestFromJSONTyped(json, false);
}

export function GroupsCreateDuplicatesRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): GroupsCreateDuplicatesRequest {
    if (json == null) {
        return json;
    }
    return {
        
        'count': json['count'] == null ? undefined : json['count'],
        'differentCase': json['different_case'] == null ? undefined : json['different_case'],
        'id': json['id'] == null ? undefined : json['id'],
        'memberEntityIds': json['member_entity_ids'] == null ? undefined : json['member_entity_ids'],
        'memberGroupIds': json['member_group_ids'] == null ? undefined : json['member_group_ids'],
        'metadata': json['metadata'] == null ? undefined : json['metadata'],
        'name': json['name'] == null ? undefined : json['name'],
        'namespaceId': json['namespace_id'] == null ? undefined : json['namespace_id'],
        'policies': json['policies'] == null ? undefined : json['policies'],
        'type': json['type'] == null ? undefined : json['type'],
    };
}

export function GroupsCreateDuplicatesRequestToJSON(json: any): GroupsCreateDuplicatesRequest {
    return GroupsCreateDuplicatesRequestToJSONTyped(json, false);
}

export function GroupsCreateDuplicatesRequestToJSONTyped(value?: GroupsCreateDuplicatesRequest | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
        'count': value['count'],
        'different_case': value['differentCase'],
        'id': value['id'],
        'member_entity_ids': value['memberEntityIds'],
        'member_group_ids': value['memberGroupIds'],
        'metadata': value['metadata'],
        'name': value['name'],
        'namespace_id': value['namespaceId'],
        'policies': value['policies'],
        'type': value['type'],
    };
}

