/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface KubernetesConfigureRequest
 */
export interface KubernetesConfigureRequest {
    /**
     * Disable defaulting to the local CA certificate and service account JWT when running in a Kubernetes pod.
     * @type {boolean}
     * @memberof KubernetesConfigureRequest
     */
    disableLocalCaJwt?: boolean;
    /**
     * PEM encoded CA certificate to use to verify the Kubernetes API server certificate. Defaults to the local pod's CA if found.
     * @type {string}
     * @memberof KubernetesConfigureRequest
     */
    kubernetesCaCert?: string;
    /**
     * Kubernetes API URL to connect to. Defaults to https://$KUBERNETES_SERVICE_HOST:KUBERNETES_SERVICE_PORT if those environment variables are set.
     * @type {string}
     * @memberof KubernetesConfigureRequest
     */
    kubernetesHost?: string;
    /**
     * The JSON web token of the service account used by the secret engine to manage Kubernetes credentials. Defaults to the local pod's JWT if found.
     * @type {string}
     * @memberof KubernetesConfigureRequest
     */
    serviceAccountJwt?: string;
}

/**
 * Check if a given object implements the KubernetesConfigureRequest interface.
 */
export function instanceOfKubernetesConfigureRequest(value: object): value is KubernetesConfigureRequest {
    return true;
}

export function KubernetesConfigureRequestFromJSON(json: any): KubernetesConfigureRequest {
    return KubernetesConfigureRequestFromJSONTyped(json, false);
}

export function KubernetesConfigureRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): KubernetesConfigureRequest {
    if (json == null) {
        return json;
    }
    return {
        
        'disableLocalCaJwt': json['disable_local_ca_jwt'] == null ? undefined : json['disable_local_ca_jwt'],
        'kubernetesCaCert': json['kubernetes_ca_cert'] == null ? undefined : json['kubernetes_ca_cert'],
        'kubernetesHost': json['kubernetes_host'] == null ? undefined : json['kubernetes_host'],
        'serviceAccountJwt': json['service_account_jwt'] == null ? undefined : json['service_account_jwt'],
    };
}

export function KubernetesConfigureRequestToJSON(json: any): KubernetesConfigureRequest {
    return KubernetesConfigureRequestToJSONTyped(json, false);
}

export function KubernetesConfigureRequestToJSONTyped(value?: KubernetesConfigureRequest | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
        'disable_local_ca_jwt': value['disableLocalCaJwt'],
        'kubernetes_ca_cert': value['kubernetesCaCert'],
        'kubernetes_host': value['kubernetesHost'],
        'service_account_jwt': value['serviceAccountJwt'],
    };
}

