/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface KubernetesGenerateCredentialsRequest
 */
export interface KubernetesGenerateCredentialsRequest {
    /**
     * The intended audiences of the generated credentials
     * @type {Array<string>}
     * @memberof KubernetesGenerateCredentialsRequest
     */
    audiences?: Array<string>;
    /**
     * If true, generate a ClusterRoleBinding to grant permissions across the whole cluster instead of within a namespace. Requires the Vault role to have kubernetes_role_type set to ClusterRole.
     * @type {boolean}
     * @memberof KubernetesGenerateCredentialsRequest
     */
    clusterRoleBinding?: boolean;
    /**
     * The name of the Kubernetes namespace in which to generate the credentials
     * @type {string}
     * @memberof KubernetesGenerateCredentialsRequest
     */
    kubernetesNamespace: string;
    /**
     * The TTL of the generated credentials
     * @type {string}
     * @memberof KubernetesGenerateCredentialsRequest
     */
    ttl?: string;
}

/**
 * Check if a given object implements the KubernetesGenerateCredentialsRequest interface.
 */
export function instanceOfKubernetesGenerateCredentialsRequest(value: object): value is KubernetesGenerateCredentialsRequest {
    if (!('kubernetesNamespace' in value) || value['kubernetesNamespace'] === undefined) return false;
    return true;
}

export function KubernetesGenerateCredentialsRequestFromJSON(json: any): KubernetesGenerateCredentialsRequest {
    return KubernetesGenerateCredentialsRequestFromJSONTyped(json, false);
}

export function KubernetesGenerateCredentialsRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): KubernetesGenerateCredentialsRequest {
    if (json == null) {
        return json;
    }
    return {
        
        'audiences': json['audiences'] == null ? undefined : json['audiences'],
        'clusterRoleBinding': json['cluster_role_binding'] == null ? undefined : json['cluster_role_binding'],
        'kubernetesNamespace': json['kubernetes_namespace'],
        'ttl': json['ttl'] == null ? undefined : json['ttl'],
    };
}

export function KubernetesGenerateCredentialsRequestToJSON(json: any): KubernetesGenerateCredentialsRequest {
    return KubernetesGenerateCredentialsRequestToJSONTyped(json, false);
}

export function KubernetesGenerateCredentialsRequestToJSONTyped(value?: KubernetesGenerateCredentialsRequest | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
        'audiences': value['audiences'],
        'cluster_role_binding': value['clusterRoleBinding'],
        'kubernetes_namespace': value['kubernetesNamespace'],
        'ttl': value['ttl'],
    };
}

