/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface KvV2WriteMetadataRequest
 */
export interface KvV2WriteMetadataRequest {
    /**
     * If true the key will require the cas parameter to be set on all write requests. If false, the backend’s configuration will be used.
     * @type {boolean}
     * @memberof KvV2WriteMetadataRequest
     */
    casRequired?: boolean;
    /**
     * User-provided key-value pairs that are used to describe arbitrary and version-agnostic information about a secret.
     * @type {object}
     * @memberof KvV2WriteMetadataRequest
     */
    customMetadata?: object;
    /**
     * The length of time before a version is deleted. If not set, the backend's configured delete_version_after is used. Cannot be greater than the backend's delete_version_after. A zero duration clears the current setting. A negative duration will cause an error.
     * @type {string}
     * @memberof KvV2WriteMetadataRequest
     */
    deleteVersionAfter?: string;
    /**
     * The number of versions to keep. If not set, the backend’s configured max version is used.
     * @type {number}
     * @memberof KvV2WriteMetadataRequest
     */
    maxVersions?: number;
}

/**
 * Check if a given object implements the KvV2WriteMetadataRequest interface.
 */
export function instanceOfKvV2WriteMetadataRequest(value: object): value is KvV2WriteMetadataRequest {
    return true;
}

export function KvV2WriteMetadataRequestFromJSON(json: any): KvV2WriteMetadataRequest {
    return KvV2WriteMetadataRequestFromJSONTyped(json, false);
}

export function KvV2WriteMetadataRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): KvV2WriteMetadataRequest {
    if (json == null) {
        return json;
    }
    return {
        
        'casRequired': json['cas_required'] == null ? undefined : json['cas_required'],
        'customMetadata': json['custom_metadata'] == null ? undefined : json['custom_metadata'],
        'deleteVersionAfter': json['delete_version_after'] == null ? undefined : json['delete_version_after'],
        'maxVersions': json['max_versions'] == null ? undefined : json['max_versions'],
    };
}

export function KvV2WriteMetadataRequestToJSON(json: any): KvV2WriteMetadataRequest {
    return KvV2WriteMetadataRequestToJSONTyped(json, false);
}

export function KvV2WriteMetadataRequestToJSONTyped(value?: KvV2WriteMetadataRequest | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
        'cas_required': value['casRequired'],
        'custom_metadata': value['customMetadata'],
        'delete_version_after': value['deleteVersionAfter'],
        'max_versions': value['maxVersions'],
    };
}

