/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface LdapWriteDynamicRoleRequest
 */
export interface LdapWriteDynamicRoleRequest {
    /**
     * LDIF string used to create new entities within the LDAP system. This LDIF can be templated.
     * @type {string}
     * @memberof LdapWriteDynamicRoleRequest
     */
    creationLdif: string;
    /**
     * Default TTL for dynamic credentials
     * @type {string}
     * @memberof LdapWriteDynamicRoleRequest
     */
    defaultTtl?: string;
    /**
     * LDIF string used to delete entities created within the LDAP system. This LDIF can be templated.
     * @type {string}
     * @memberof LdapWriteDynamicRoleRequest
     */
    deletionLdif: string;
    /**
     * Max TTL a dynamic credential can be extended to
     * @type {string}
     * @memberof LdapWriteDynamicRoleRequest
     */
    maxTtl?: string;
    /**
     * LDIF string used to rollback changes in the event of a failure to create credentials. This LDIF can be templated.
     * @type {string}
     * @memberof LdapWriteDynamicRoleRequest
     */
    rollbackLdif?: string;
    /**
     * The template used to create a username
     * @type {string}
     * @memberof LdapWriteDynamicRoleRequest
     */
    usernameTemplate?: string;
}

/**
 * Check if a given object implements the LdapWriteDynamicRoleRequest interface.
 */
export function instanceOfLdapWriteDynamicRoleRequest(value: object): value is LdapWriteDynamicRoleRequest {
    if (!('creationLdif' in value) || value['creationLdif'] === undefined) return false;
    if (!('deletionLdif' in value) || value['deletionLdif'] === undefined) return false;
    return true;
}

export function LdapWriteDynamicRoleRequestFromJSON(json: any): LdapWriteDynamicRoleRequest {
    return LdapWriteDynamicRoleRequestFromJSONTyped(json, false);
}

export function LdapWriteDynamicRoleRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): LdapWriteDynamicRoleRequest {
    if (json == null) {
        return json;
    }
    return {
        
        'creationLdif': json['creation_ldif'],
        'defaultTtl': json['default_ttl'] == null ? undefined : json['default_ttl'],
        'deletionLdif': json['deletion_ldif'],
        'maxTtl': json['max_ttl'] == null ? undefined : json['max_ttl'],
        'rollbackLdif': json['rollback_ldif'] == null ? undefined : json['rollback_ldif'],
        'usernameTemplate': json['username_template'] == null ? undefined : json['username_template'],
    };
}

export function LdapWriteDynamicRoleRequestToJSON(json: any): LdapWriteDynamicRoleRequest {
    return LdapWriteDynamicRoleRequestToJSONTyped(json, false);
}

export function LdapWriteDynamicRoleRequestToJSONTyped(value?: LdapWriteDynamicRoleRequest | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
        'creation_ldif': value['creationLdif'],
        'default_ttl': value['defaultTtl'],
        'deletion_ldif': value['deletionLdif'],
        'max_ttl': value['maxTtl'],
        'rollback_ldif': value['rollbackLdif'],
        'username_template': value['usernameTemplate'],
    };
}

