/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface MountsTuneConfigurationParametersRequest
 */
export interface MountsTuneConfigurationParametersRequest {
    /**
     * 
     * @type {Array<string>}
     * @memberof MountsTuneConfigurationParametersRequest
     */
    allowedManagedKeys?: Array<string>;
    /**
     * A list of headers to whitelist and allow a plugin to set on responses.
     * @type {Array<string>}
     * @memberof MountsTuneConfigurationParametersRequest
     */
    allowedResponseHeaders?: Array<string>;
    /**
     * The list of keys in the request data object that will not be HMAC'd by audit devices.
     * @type {Array<string>}
     * @memberof MountsTuneConfigurationParametersRequest
     */
    auditNonHmacRequestKeys?: Array<string>;
    /**
     * The list of keys in the response data object that will not be HMAC'd by audit devices.
     * @type {Array<string>}
     * @memberof MountsTuneConfigurationParametersRequest
     */
    auditNonHmacResponseKeys?: Array<string>;
    /**
     * The default lease TTL for this mount.
     * @type {string}
     * @memberof MountsTuneConfigurationParametersRequest
     */
    defaultLeaseTtl?: string;
    /**
     * 
     * @type {Array<string>}
     * @memberof MountsTuneConfigurationParametersRequest
     */
    delegatedAuthAccessors?: Array<string>;
    /**
     * User-friendly description for this credential backend.
     * @type {string}
     * @memberof MountsTuneConfigurationParametersRequest
     */
    description?: string;
    /**
     * The name of the key used to sign plugin identity tokens. Defaults to the default key.
     * @type {string}
     * @memberof MountsTuneConfigurationParametersRequest
     */
    identityTokenKey?: string;
    /**
     * Determines the visibility of the mount in the UI-specific listing endpoint. Accepted value are 'unauth' and 'hidden', with the empty default ('') behaving like 'hidden'.
     * @type {string}
     * @memberof MountsTuneConfigurationParametersRequest
     */
    listingVisibility?: string;
    /**
     * The max lease TTL for this mount.
     * @type {string}
     * @memberof MountsTuneConfigurationParametersRequest
     */
    maxLeaseTtl?: string;
    /**
     * The options to pass into the backend. Should be a json object with string keys and values.
     * @type {object}
     * @memberof MountsTuneConfigurationParametersRequest
     */
    options?: object;
    /**
     * A list of headers to whitelist and pass from the request to the plugin.
     * @type {Array<string>}
     * @memberof MountsTuneConfigurationParametersRequest
     */
    passthroughRequestHeaders?: Array<string>;
    /**
     * The semantic version of the plugin to use, or image tag if oci_image is provided.
     * @type {string}
     * @memberof MountsTuneConfigurationParametersRequest
     */
    pluginVersion?: string;
    /**
     * The type of token to issue (service or batch).
     * @type {string}
     * @memberof MountsTuneConfigurationParametersRequest
     */
    tokenType?: string;
    /**
     * Whether to trim a trailing slash on incoming requests to this mount
     * @type {boolean}
     * @memberof MountsTuneConfigurationParametersRequest
     */
    trimRequestTrailingSlashes?: boolean;
    /**
     * The user lockout configuration to pass into the backend. Should be a json object with string keys and values.
     * @type {object}
     * @memberof MountsTuneConfigurationParametersRequest
     */
    userLockoutConfig?: object;
}

/**
 * Check if a given object implements the MountsTuneConfigurationParametersRequest interface.
 */
export function instanceOfMountsTuneConfigurationParametersRequest(value: object): value is MountsTuneConfigurationParametersRequest {
    return true;
}

export function MountsTuneConfigurationParametersRequestFromJSON(json: any): MountsTuneConfigurationParametersRequest {
    return MountsTuneConfigurationParametersRequestFromJSONTyped(json, false);
}

export function MountsTuneConfigurationParametersRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): MountsTuneConfigurationParametersRequest {
    if (json == null) {
        return json;
    }
    return {
        
        'allowedManagedKeys': json['allowed_managed_keys'] == null ? undefined : json['allowed_managed_keys'],
        'allowedResponseHeaders': json['allowed_response_headers'] == null ? undefined : json['allowed_response_headers'],
        'auditNonHmacRequestKeys': json['audit_non_hmac_request_keys'] == null ? undefined : json['audit_non_hmac_request_keys'],
        'auditNonHmacResponseKeys': json['audit_non_hmac_response_keys'] == null ? undefined : json['audit_non_hmac_response_keys'],
        'defaultLeaseTtl': json['default_lease_ttl'] == null ? undefined : json['default_lease_ttl'],
        'delegatedAuthAccessors': json['delegated_auth_accessors'] == null ? undefined : json['delegated_auth_accessors'],
        'description': json['description'] == null ? undefined : json['description'],
        'identityTokenKey': json['identity_token_key'] == null ? undefined : json['identity_token_key'],
        'listingVisibility': json['listing_visibility'] == null ? undefined : json['listing_visibility'],
        'maxLeaseTtl': json['max_lease_ttl'] == null ? undefined : json['max_lease_ttl'],
        'options': json['options'] == null ? undefined : json['options'],
        'passthroughRequestHeaders': json['passthrough_request_headers'] == null ? undefined : json['passthrough_request_headers'],
        'pluginVersion': json['plugin_version'] == null ? undefined : json['plugin_version'],
        'tokenType': json['token_type'] == null ? undefined : json['token_type'],
        'trimRequestTrailingSlashes': json['trim_request_trailing_slashes'] == null ? undefined : json['trim_request_trailing_slashes'],
        'userLockoutConfig': json['user_lockout_config'] == null ? undefined : json['user_lockout_config'],
    };
}

export function MountsTuneConfigurationParametersRequestToJSON(json: any): MountsTuneConfigurationParametersRequest {
    return MountsTuneConfigurationParametersRequestToJSONTyped(json, false);
}

export function MountsTuneConfigurationParametersRequestToJSONTyped(value?: MountsTuneConfigurationParametersRequest | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
        'allowed_managed_keys': value['allowedManagedKeys'],
        'allowed_response_headers': value['allowedResponseHeaders'],
        'audit_non_hmac_request_keys': value['auditNonHmacRequestKeys'],
        'audit_non_hmac_response_keys': value['auditNonHmacResponseKeys'],
        'default_lease_ttl': value['defaultLeaseTtl'],
        'delegated_auth_accessors': value['delegatedAuthAccessors'],
        'description': value['description'],
        'identity_token_key': value['identityTokenKey'],
        'listing_visibility': value['listingVisibility'],
        'max_lease_ttl': value['maxLeaseTtl'],
        'options': value['options'],
        'passthrough_request_headers': value['passthroughRequestHeaders'],
        'plugin_version': value['pluginVersion'],
        'token_type': value['tokenType'],
        'trim_request_trailing_slashes': value['trimRequestTrailingSlashes'],
        'user_lockout_config': value['userLockoutConfig'],
    };
}

