/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface NomadConfigureAccessRequest
 */
export interface NomadConfigureAccessRequest {
    /**
     * Nomad server address
     * @type {string}
     * @memberof NomadConfigureAccessRequest
     */
    address?: string;
    /**
     * CA certificate to use when verifying Nomad server certificate, must be x509 PEM encoded.
     * @type {string}
     * @memberof NomadConfigureAccessRequest
     */
    caCert?: string;
    /**
     * Client certificate used for Nomad's TLS communication, must be x509 PEM encoded and if this is set you need to also set client_key.
     * @type {string}
     * @memberof NomadConfigureAccessRequest
     */
    clientCert?: string;
    /**
     * Client key used for Nomad's TLS communication, must be x509 PEM encoded and if this is set you need to also set client_cert.
     * @type {string}
     * @memberof NomadConfigureAccessRequest
     */
    clientKey?: string;
    /**
     * Max length for name of generated Nomad tokens
     * @type {number}
     * @memberof NomadConfigureAccessRequest
     */
    maxTokenNameLength?: number;
    /**
     * Token for API calls
     * @type {string}
     * @memberof NomadConfigureAccessRequest
     */
    token?: string;
}

/**
 * Check if a given object implements the NomadConfigureAccessRequest interface.
 */
export function instanceOfNomadConfigureAccessRequest(value: object): value is NomadConfigureAccessRequest {
    return true;
}

export function NomadConfigureAccessRequestFromJSON(json: any): NomadConfigureAccessRequest {
    return NomadConfigureAccessRequestFromJSONTyped(json, false);
}

export function NomadConfigureAccessRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): NomadConfigureAccessRequest {
    if (json == null) {
        return json;
    }
    return {
        
        'address': json['address'] == null ? undefined : json['address'],
        'caCert': json['ca_cert'] == null ? undefined : json['ca_cert'],
        'clientCert': json['client_cert'] == null ? undefined : json['client_cert'],
        'clientKey': json['client_key'] == null ? undefined : json['client_key'],
        'maxTokenNameLength': json['max_token_name_length'] == null ? undefined : json['max_token_name_length'],
        'token': json['token'] == null ? undefined : json['token'],
    };
}

export function NomadConfigureAccessRequestToJSON(json: any): NomadConfigureAccessRequest {
    return NomadConfigureAccessRequestToJSONTyped(json, false);
}

export function NomadConfigureAccessRequestToJSONTyped(value?: NomadConfigureAccessRequest | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
        'address': value['address'],
        'ca_cert': value['caCert'],
        'client_cert': value['clientCert'],
        'client_key': value['clientKey'],
        'max_token_name_length': value['maxTokenNameLength'],
        'token': value['token'],
    };
}

