/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface OidcWriteClientRequest
 */
export interface OidcWriteClientRequest {
    /**
     * The time-to-live for access tokens obtained by the client.
     * @type {string}
     * @memberof OidcWriteClientRequest
     */
    accessTokenTtl?: string;
    /**
     * Comma separated string or array of assignment resources.
     * @type {Array<string>}
     * @memberof OidcWriteClientRequest
     */
    assignments?: Array<string>;
    /**
     * The client type based on its ability to maintain confidentiality of credentials. The following client types are supported: 'confidential', 'public'. Defaults to 'confidential'.
     * @type {string}
     * @memberof OidcWriteClientRequest
     */
    clientType?: string;
    /**
     * The time-to-live for ID tokens obtained by the client.
     * @type {string}
     * @memberof OidcWriteClientRequest
     */
    idTokenTtl?: string;
    /**
     * A reference to a named key resource. Cannot be modified after creation. Defaults to the 'default' key.
     * @type {string}
     * @memberof OidcWriteClientRequest
     */
    key?: string;
    /**
     * Comma separated string or array of redirect URIs used by the client. One of these values must exactly match the redirect_uri parameter value used in each authentication request.
     * @type {Array<string>}
     * @memberof OidcWriteClientRequest
     */
    redirectUris?: Array<string>;
}

/**
 * Check if a given object implements the OidcWriteClientRequest interface.
 */
export function instanceOfOidcWriteClientRequest(value: object): value is OidcWriteClientRequest {
    return true;
}

export function OidcWriteClientRequestFromJSON(json: any): OidcWriteClientRequest {
    return OidcWriteClientRequestFromJSONTyped(json, false);
}

export function OidcWriteClientRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): OidcWriteClientRequest {
    if (json == null) {
        return json;
    }
    return {
        
        'accessTokenTtl': json['access_token_ttl'] == null ? undefined : json['access_token_ttl'],
        'assignments': json['assignments'] == null ? undefined : json['assignments'],
        'clientType': json['client_type'] == null ? undefined : json['client_type'],
        'idTokenTtl': json['id_token_ttl'] == null ? undefined : json['id_token_ttl'],
        'key': json['key'] == null ? undefined : json['key'],
        'redirectUris': json['redirect_uris'] == null ? undefined : json['redirect_uris'],
    };
}

export function OidcWriteClientRequestToJSON(json: any): OidcWriteClientRequest {
    return OidcWriteClientRequestToJSONTyped(json, false);
}

export function OidcWriteClientRequestToJSONTyped(value?: OidcWriteClientRequest | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
        'access_token_ttl': value['accessTokenTtl'],
        'assignments': value['assignments'],
        'client_type': value['clientType'],
        'id_token_ttl': value['idTokenTtl'],
        'key': value['key'],
        'redirect_uris': value['redirectUris'],
    };
}

