/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface PkiConfigureAutoTidyResponse
 */
export interface PkiConfigureAutoTidyResponse {
    /**
     * Safety buffer after creation after which accounts lacking orders are revoked
     * @type {number}
     * @memberof PkiConfigureAutoTidyResponse
     */
    acmeAccountSafetyBuffer?: number;
    /**
     * Specifies whether automatic tidy is enabled or not
     * @type {boolean}
     * @memberof PkiConfigureAutoTidyResponse
     */
    enabled?: boolean;
    /**
     * Specifies the duration between automatic tidy operation
     * @type {number}
     * @memberof PkiConfigureAutoTidyResponse
     */
    intervalDuration?: number;
    /**
     * Issuer safety buffer
     * @type {number}
     * @memberof PkiConfigureAutoTidyResponse
     */
    issuerSafetyBuffer?: number;
    /**
     * 
     * @type {boolean}
     * @memberof PkiConfigureAutoTidyResponse
     */
    maintainStoredCertificateCounts?: boolean;
    /**
     * The maximum amount of time in seconds auto-tidy will be delayed after startup
     * @type {number}
     * @memberof PkiConfigureAutoTidyResponse
     */
    maxStartupBackoffDuration?: number;
    /**
     * The minimum amount of time in seconds auto-tidy will be delayed after startup
     * @type {number}
     * @memberof PkiConfigureAutoTidyResponse
     */
    minStartupBackoffDuration?: number;
    /**
     * Duration to pause between tidying certificates
     * @type {string}
     * @memberof PkiConfigureAutoTidyResponse
     */
    pauseDuration?: string;
    /**
     * 
     * @type {boolean}
     * @memberof PkiConfigureAutoTidyResponse
     */
    publishStoredCertificateCountMetrics?: boolean;
    /**
     * 
     * @type {number}
     * @memberof PkiConfigureAutoTidyResponse
     */
    revocationQueueSafetyBuffer?: number;
    /**
     * Safety buffer time duration
     * @type {number}
     * @memberof PkiConfigureAutoTidyResponse
     */
    safetyBuffer?: number;
    /**
     * Tidy Unused Acme Accounts, and Orders
     * @type {boolean}
     * @memberof PkiConfigureAutoTidyResponse
     */
    tidyAcme?: boolean;
    /**
     * Tidy cert metadata
     * @type {boolean}
     * @memberof PkiConfigureAutoTidyResponse
     */
    tidyCertMetadata?: boolean;
    /**
     * Specifies whether to tidy up the certificate store
     * @type {boolean}
     * @memberof PkiConfigureAutoTidyResponse
     */
    tidyCertStore?: boolean;
    /**
     * Tidy CMPv2 nonce store
     * @type {boolean}
     * @memberof PkiConfigureAutoTidyResponse
     */
    tidyCmpv2NonceStore?: boolean;
    /**
     * Tidy the cross-cluster revoked certificate store
     * @type {boolean}
     * @memberof PkiConfigureAutoTidyResponse
     */
    tidyCrossClusterRevokedCerts?: boolean;
    /**
     * Specifies whether tidy expired issuers
     * @type {boolean}
     * @memberof PkiConfigureAutoTidyResponse
     */
    tidyExpiredIssuers?: boolean;
    /**
     * 
     * @type {boolean}
     * @memberof PkiConfigureAutoTidyResponse
     */
    tidyMoveLegacyCaBundle?: boolean;
    /**
     * 
     * @type {boolean}
     * @memberof PkiConfigureAutoTidyResponse
     */
    tidyRevocationQueue?: boolean;
    /**
     * Specifies whether to associate revoked certificates with their corresponding issuers
     * @type {boolean}
     * @memberof PkiConfigureAutoTidyResponse
     */
    tidyRevokedCertIssuerAssociations?: boolean;
    /**
     * Specifies whether to remove all invalid and expired certificates from storage
     * @type {boolean}
     * @memberof PkiConfigureAutoTidyResponse
     */
    tidyRevokedCerts?: boolean;
}

/**
 * Check if a given object implements the PkiConfigureAutoTidyResponse interface.
 */
export function instanceOfPkiConfigureAutoTidyResponse(value: object): value is PkiConfigureAutoTidyResponse {
    return true;
}

export function PkiConfigureAutoTidyResponseFromJSON(json: any): PkiConfigureAutoTidyResponse {
    return PkiConfigureAutoTidyResponseFromJSONTyped(json, false);
}

export function PkiConfigureAutoTidyResponseFromJSONTyped(json: any, ignoreDiscriminator: boolean): PkiConfigureAutoTidyResponse {
    if (json == null) {
        return json;
    }
    return {
        
        'acmeAccountSafetyBuffer': json['acme_account_safety_buffer'] == null ? undefined : json['acme_account_safety_buffer'],
        'enabled': json['enabled'] == null ? undefined : json['enabled'],
        'intervalDuration': json['interval_duration'] == null ? undefined : json['interval_duration'],
        'issuerSafetyBuffer': json['issuer_safety_buffer'] == null ? undefined : json['issuer_safety_buffer'],
        'maintainStoredCertificateCounts': json['maintain_stored_certificate_counts'] == null ? undefined : json['maintain_stored_certificate_counts'],
        'maxStartupBackoffDuration': json['max_startup_backoff_duration'] == null ? undefined : json['max_startup_backoff_duration'],
        'minStartupBackoffDuration': json['min_startup_backoff_duration'] == null ? undefined : json['min_startup_backoff_duration'],
        'pauseDuration': json['pause_duration'] == null ? undefined : json['pause_duration'],
        'publishStoredCertificateCountMetrics': json['publish_stored_certificate_count_metrics'] == null ? undefined : json['publish_stored_certificate_count_metrics'],
        'revocationQueueSafetyBuffer': json['revocation_queue_safety_buffer'] == null ? undefined : json['revocation_queue_safety_buffer'],
        'safetyBuffer': json['safety_buffer'] == null ? undefined : json['safety_buffer'],
        'tidyAcme': json['tidy_acme'] == null ? undefined : json['tidy_acme'],
        'tidyCertMetadata': json['tidy_cert_metadata'] == null ? undefined : json['tidy_cert_metadata'],
        'tidyCertStore': json['tidy_cert_store'] == null ? undefined : json['tidy_cert_store'],
        'tidyCmpv2NonceStore': json['tidy_cmpv2_nonce_store'] == null ? undefined : json['tidy_cmpv2_nonce_store'],
        'tidyCrossClusterRevokedCerts': json['tidy_cross_cluster_revoked_certs'] == null ? undefined : json['tidy_cross_cluster_revoked_certs'],
        'tidyExpiredIssuers': json['tidy_expired_issuers'] == null ? undefined : json['tidy_expired_issuers'],
        'tidyMoveLegacyCaBundle': json['tidy_move_legacy_ca_bundle'] == null ? undefined : json['tidy_move_legacy_ca_bundle'],
        'tidyRevocationQueue': json['tidy_revocation_queue'] == null ? undefined : json['tidy_revocation_queue'],
        'tidyRevokedCertIssuerAssociations': json['tidy_revoked_cert_issuer_associations'] == null ? undefined : json['tidy_revoked_cert_issuer_associations'],
        'tidyRevokedCerts': json['tidy_revoked_certs'] == null ? undefined : json['tidy_revoked_certs'],
    };
}

export function PkiConfigureAutoTidyResponseToJSON(json: any): PkiConfigureAutoTidyResponse {
    return PkiConfigureAutoTidyResponseToJSONTyped(json, false);
}

export function PkiConfigureAutoTidyResponseToJSONTyped(value?: PkiConfigureAutoTidyResponse | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
        'acme_account_safety_buffer': value['acmeAccountSafetyBuffer'],
        'enabled': value['enabled'],
        'interval_duration': value['intervalDuration'],
        'issuer_safety_buffer': value['issuerSafetyBuffer'],
        'maintain_stored_certificate_counts': value['maintainStoredCertificateCounts'],
        'max_startup_backoff_duration': value['maxStartupBackoffDuration'],
        'min_startup_backoff_duration': value['minStartupBackoffDuration'],
        'pause_duration': value['pauseDuration'],
        'publish_stored_certificate_count_metrics': value['publishStoredCertificateCountMetrics'],
        'revocation_queue_safety_buffer': value['revocationQueueSafetyBuffer'],
        'safety_buffer': value['safetyBuffer'],
        'tidy_acme': value['tidyAcme'],
        'tidy_cert_metadata': value['tidyCertMetadata'],
        'tidy_cert_store': value['tidyCertStore'],
        'tidy_cmpv2_nonce_store': value['tidyCmpv2NonceStore'],
        'tidy_cross_cluster_revoked_certs': value['tidyCrossClusterRevokedCerts'],
        'tidy_expired_issuers': value['tidyExpiredIssuers'],
        'tidy_move_legacy_ca_bundle': value['tidyMoveLegacyCaBundle'],
        'tidy_revocation_queue': value['tidyRevocationQueue'],
        'tidy_revoked_cert_issuer_associations': value['tidyRevokedCertIssuerAssociations'],
        'tidy_revoked_certs': value['tidyRevokedCerts'],
    };
}

