/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface PkiConfigureClusterResponse
 */
export interface PkiConfigureClusterResponse {
    /**
     * Optional URI to this mount's AIA distribution point; may refer to an external non-Vault responder. This is for resolving AIA URLs and providing the {{cluster_aia_path}} template parameter and will not be used for other purposes. As such, unlike path above, this could safely be an insecure transit mechanism (like HTTP without TLS). For example: http://cdn.example.com/pr1/pki
     * @type {string}
     * @memberof PkiConfigureClusterResponse
     */
    aiaPath?: string;
    /**
     * Canonical URI to this mount on this performance replication cluster's external address. This is for resolving AIA URLs and providing the {{cluster_path}} template parameter but might be used for other purposes in the future. This should only point back to this particular PR replica and should not ever point to another PR cluster. It may point to any node in the PR replica, including standby nodes, and need not always point to the active node. For example: https://pr1.vault.example.com:8200/v1/pki
     * @type {string}
     * @memberof PkiConfigureClusterResponse
     */
    path?: string;
}

/**
 * Check if a given object implements the PkiConfigureClusterResponse interface.
 */
export function instanceOfPkiConfigureClusterResponse(value: object): value is PkiConfigureClusterResponse {
    return true;
}

export function PkiConfigureClusterResponseFromJSON(json: any): PkiConfigureClusterResponse {
    return PkiConfigureClusterResponseFromJSONTyped(json, false);
}

export function PkiConfigureClusterResponseFromJSONTyped(json: any, ignoreDiscriminator: boolean): PkiConfigureClusterResponse {
    if (json == null) {
        return json;
    }
    return {
        
        'aiaPath': json['aia_path'] == null ? undefined : json['aia_path'],
        'path': json['path'] == null ? undefined : json['path'],
    };
}

export function PkiConfigureClusterResponseToJSON(json: any): PkiConfigureClusterResponse {
    return PkiConfigureClusterResponseToJSONTyped(json, false);
}

export function PkiConfigureClusterResponseToJSONTyped(value?: PkiConfigureClusterResponse | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
        'aia_path': value['aiaPath'],
        'path': value['path'],
    };
}

