/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface PkiConfigureCrlResponse
 */
export interface PkiConfigureCrlResponse {
    /**
     * If set to true, enables automatic rebuilding of the CRL
     * @type {boolean}
     * @memberof PkiConfigureCrlResponse
     */
    autoRebuild?: boolean;
    /**
     * The time before the CRL expires to automatically rebuild it, when enabled. Must be shorter than the CRL expiry. Defaults to 12h.
     * @type {string}
     * @memberof PkiConfigureCrlResponse
     */
    autoRebuildGracePeriod?: string;
    /**
     * Whether to enable a global, cross-cluster revocation queue. Must be used with auto_rebuild=true.
     * @type {boolean}
     * @memberof PkiConfigureCrlResponse
     */
    crossClusterRevocation?: boolean;
    /**
     * The time between delta CRL rebuilds if a new revocation has occurred. Must be shorter than the CRL expiry. Defaults to 15m.
     * @type {string}
     * @memberof PkiConfigureCrlResponse
     */
    deltaRebuildInterval?: string;
    /**
     * If set to true, disables generating the CRL entirely.
     * @type {boolean}
     * @memberof PkiConfigureCrlResponse
     */
    disable?: boolean;
    /**
     * Whether to enable delta CRLs between authoritative CRL rebuilds
     * @type {boolean}
     * @memberof PkiConfigureCrlResponse
     */
    enableDelta?: boolean;
    /**
     * The amount of time the generated CRL should be valid; defaults to 72 hours
     * @type {string}
     * @memberof PkiConfigureCrlResponse
     */
    expiry?: string;
    /**
     * The maximum number of entries the CRL can contain. This is meant as a guard against accidental runaway revocations overloading Vault storage. If this limit is exceeded writing the CRL will fail. If set to -1 this limit is disabled.
     * @type {number}
     * @memberof PkiConfigureCrlResponse
     */
    maxCrlEntries?: number;
    /**
     * If set to true, ocsp unauthorized responses will be returned.
     * @type {boolean}
     * @memberof PkiConfigureCrlResponse
     */
    ocspDisable?: boolean;
    /**
     * The amount of time an OCSP response will be valid (controls the NextUpdate field); defaults to 12 hours
     * @type {string}
     * @memberof PkiConfigureCrlResponse
     */
    ocspExpiry?: string;
    /**
     * If set to true enables global replication of revocation entries, also enabling unified versions of OCSP and CRLs if their respective features are enabled. disable for CRLs and ocsp_disable for OCSP.
     * @type {boolean}
     * @memberof PkiConfigureCrlResponse
     */
    unifiedCrl?: boolean;
    /**
     * If set to true, existing CRL and OCSP paths will return the unified CRL instead of a response based on cluster-local data
     * @type {boolean}
     * @memberof PkiConfigureCrlResponse
     */
    unifiedCrlOnExistingPaths?: boolean;
}

/**
 * Check if a given object implements the PkiConfigureCrlResponse interface.
 */
export function instanceOfPkiConfigureCrlResponse(value: object): value is PkiConfigureCrlResponse {
    return true;
}

export function PkiConfigureCrlResponseFromJSON(json: any): PkiConfigureCrlResponse {
    return PkiConfigureCrlResponseFromJSONTyped(json, false);
}

export function PkiConfigureCrlResponseFromJSONTyped(json: any, ignoreDiscriminator: boolean): PkiConfigureCrlResponse {
    if (json == null) {
        return json;
    }
    return {
        
        'autoRebuild': json['auto_rebuild'] == null ? undefined : json['auto_rebuild'],
        'autoRebuildGracePeriod': json['auto_rebuild_grace_period'] == null ? undefined : json['auto_rebuild_grace_period'],
        'crossClusterRevocation': json['cross_cluster_revocation'] == null ? undefined : json['cross_cluster_revocation'],
        'deltaRebuildInterval': json['delta_rebuild_interval'] == null ? undefined : json['delta_rebuild_interval'],
        'disable': json['disable'] == null ? undefined : json['disable'],
        'enableDelta': json['enable_delta'] == null ? undefined : json['enable_delta'],
        'expiry': json['expiry'] == null ? undefined : json['expiry'],
        'maxCrlEntries': json['max_crl_entries'] == null ? undefined : json['max_crl_entries'],
        'ocspDisable': json['ocsp_disable'] == null ? undefined : json['ocsp_disable'],
        'ocspExpiry': json['ocsp_expiry'] == null ? undefined : json['ocsp_expiry'],
        'unifiedCrl': json['unified_crl'] == null ? undefined : json['unified_crl'],
        'unifiedCrlOnExistingPaths': json['unified_crl_on_existing_paths'] == null ? undefined : json['unified_crl_on_existing_paths'],
    };
}

export function PkiConfigureCrlResponseToJSON(json: any): PkiConfigureCrlResponse {
    return PkiConfigureCrlResponseToJSONTyped(json, false);
}

export function PkiConfigureCrlResponseToJSONTyped(value?: PkiConfigureCrlResponse | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
        'auto_rebuild': value['autoRebuild'],
        'auto_rebuild_grace_period': value['autoRebuildGracePeriod'],
        'cross_cluster_revocation': value['crossClusterRevocation'],
        'delta_rebuild_interval': value['deltaRebuildInterval'],
        'disable': value['disable'],
        'enable_delta': value['enableDelta'],
        'expiry': value['expiry'],
        'max_crl_entries': value['maxCrlEntries'],
        'ocsp_disable': value['ocspDisable'],
        'ocsp_expiry': value['ocspExpiry'],
        'unified_crl': value['unifiedCrl'],
        'unified_crl_on_existing_paths': value['unifiedCrlOnExistingPaths'],
    };
}

