/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface PkiConfigureEstRequest
 */
export interface PkiConfigureEstRequest {
    /**
     * Fields parsed from the CSR that appear in the audit and can be used by sentinel policies. Options are: [csr common_name alt_names ip_sans uri_sans other_sans signature_bits exclude_cn_from_sans ou organization country locality province street_address postal_code serial_number use_pss key_type key_bits add_basic_constraints]
     * @type {Array<string>}
     * @memberof PkiConfigureEstRequest
     */
    auditFields?: Array<string>;
    /**
     * A map of authentication type to authentication parameters
     * @type {object}
     * @memberof PkiConfigureEstRequest
     */
    authenticators?: object;
    /**
     * Indicates if this mount owns the .well-known/est mount path
     * @type {boolean}
     * @memberof PkiConfigureEstRequest
     */
    defaultMount?: boolean;
    /**
     * the policy of the default EST responder path, required if default_mount is true
     * @type {string}
     * @memberof PkiConfigureEstRequest
     */
    defaultPathPolicy?: string;
    /**
     * Parse CSR to that its fields can be used by sentinel policies.
     * @type {boolean}
     * @memberof PkiConfigureEstRequest
     */
    enableSentinelParsing?: boolean;
    /**
     * whether EST is enabled, defaults to false
     * @type {boolean}
     * @memberof PkiConfigureEstRequest
     */
    enabled?: boolean;
    /**
     * The EST label to register and its associated role path
     * @type {object}
     * @memberof PkiConfigureEstRequest
     */
    labelToPathPolicy?: object;
}

/**
 * Check if a given object implements the PkiConfigureEstRequest interface.
 */
export function instanceOfPkiConfigureEstRequest(value: object): value is PkiConfigureEstRequest {
    return true;
}

export function PkiConfigureEstRequestFromJSON(json: any): PkiConfigureEstRequest {
    return PkiConfigureEstRequestFromJSONTyped(json, false);
}

export function PkiConfigureEstRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): PkiConfigureEstRequest {
    if (json == null) {
        return json;
    }
    return {
        
        'auditFields': json['audit_fields'] == null ? undefined : json['audit_fields'],
        'authenticators': json['authenticators'] == null ? undefined : json['authenticators'],
        'defaultMount': json['default_mount'] == null ? undefined : json['default_mount'],
        'defaultPathPolicy': json['default_path_policy'] == null ? undefined : json['default_path_policy'],
        'enableSentinelParsing': json['enable_sentinel_parsing'] == null ? undefined : json['enable_sentinel_parsing'],
        'enabled': json['enabled'] == null ? undefined : json['enabled'],
        'labelToPathPolicy': json['label_to_path_policy'] == null ? undefined : json['label_to_path_policy'],
    };
}

export function PkiConfigureEstRequestToJSON(json: any): PkiConfigureEstRequest {
    return PkiConfigureEstRequestToJSONTyped(json, false);
}

export function PkiConfigureEstRequestToJSONTyped(value?: PkiConfigureEstRequest | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
        'audit_fields': value['auditFields'],
        'authenticators': value['authenticators'],
        'default_mount': value['defaultMount'],
        'default_path_policy': value['defaultPathPolicy'],
        'enable_sentinel_parsing': value['enableSentinelParsing'],
        'enabled': value['enabled'],
        'label_to_path_policy': value['labelToPathPolicy'],
    };
}

