/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface PkiGenerateExportedKeyRequest
 */
export interface PkiGenerateExportedKeyRequest {
    /**
     * The number of bits to use. Allowed values are 0 (universal default); with rsa key_type: 2048 (default), 3072, 4096 or 8192; with ec key_type: 224, 256 (default), 384, or 521; ignored with ed25519.
     * @type {number}
     * @memberof PkiGenerateExportedKeyRequest
     */
    keyBits?: number;
    /**
     * Optional name to be used for this key
     * @type {string}
     * @memberof PkiGenerateExportedKeyRequest
     */
    keyName?: string;
    /**
     * The type of key to use; defaults to RSA. "rsa" "ec" and "ed25519" are the only valid values.
     * @type {string}
     * @memberof PkiGenerateExportedKeyRequest
     */
    keyType?: PkiGenerateExportedKeyRequestKeyTypeEnum;
    /**
     * The name of the managed key to use when the exported type is kms. When kms type is the key type, this field or managed_key_name is required. Ignored for other types.
     * @type {string}
     * @memberof PkiGenerateExportedKeyRequest
     */
    managedKeyId?: string;
    /**
     * The name of the managed key to use when the exported type is kms. When kms type is the key type, this field or managed_key_id is required. Ignored for other types.
     * @type {string}
     * @memberof PkiGenerateExportedKeyRequest
     */
    managedKeyName?: string;
}

/**
* @export
* @enum {string}
*/
export enum PkiGenerateExportedKeyRequestKeyTypeEnum {
    RSA = 'rsa',
    EC = 'ec',
    ED25519 = 'ed25519'
}


/**
 * Check if a given object implements the PkiGenerateExportedKeyRequest interface.
 */
export function instanceOfPkiGenerateExportedKeyRequest(value: object): value is PkiGenerateExportedKeyRequest {
    return true;
}

export function PkiGenerateExportedKeyRequestFromJSON(json: any): PkiGenerateExportedKeyRequest {
    return PkiGenerateExportedKeyRequestFromJSONTyped(json, false);
}

export function PkiGenerateExportedKeyRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): PkiGenerateExportedKeyRequest {
    if (json == null) {
        return json;
    }
    return {
        
        'keyBits': json['key_bits'] == null ? undefined : json['key_bits'],
        'keyName': json['key_name'] == null ? undefined : json['key_name'],
        'keyType': json['key_type'] == null ? undefined : json['key_type'],
        'managedKeyId': json['managed_key_id'] == null ? undefined : json['managed_key_id'],
        'managedKeyName': json['managed_key_name'] == null ? undefined : json['managed_key_name'],
    };
}

export function PkiGenerateExportedKeyRequestToJSON(json: any): PkiGenerateExportedKeyRequest {
    return PkiGenerateExportedKeyRequestToJSONTyped(json, false);
}

export function PkiGenerateExportedKeyRequestToJSONTyped(value?: PkiGenerateExportedKeyRequest | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
        'key_bits': value['keyBits'],
        'key_name': value['keyName'],
        'key_type': value['keyType'],
        'managed_key_id': value['managedKeyId'],
        'managed_key_name': value['managedKeyName'],
    };
}

