/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface PkiIssuerResignCrlsRequest
 */
export interface PkiIssuerResignCrlsRequest {
    /**
     * The sequence number to be written within the CRL Number extension.
     * @type {number}
     * @memberof PkiIssuerResignCrlsRequest
     */
    crlNumber?: number;
    /**
     * A list of PEM encoded CRLs to combine, originally signed by the requested issuer.
     * @type {Array<string>}
     * @memberof PkiIssuerResignCrlsRequest
     */
    crls?: Array<string>;
    /**
     * Using a zero or greater value specifies the base CRL revision number to encode within a Delta CRL indicator extension, otherwise the extension will not be added.
     * @type {number}
     * @memberof PkiIssuerResignCrlsRequest
     */
    deltaCrlBaseNumber?: number;
    /**
     * The format of the combined CRL, can be "pem" or "der". If "der", the value will be base64 encoded. Defaults to "pem".
     * @type {string}
     * @memberof PkiIssuerResignCrlsRequest
     */
    format?: string;
    /**
     * The amount of time the generated CRL should be valid; defaults to 72 hours.
     * @type {string}
     * @memberof PkiIssuerResignCrlsRequest
     */
    nextUpdate?: string;
}

/**
 * Check if a given object implements the PkiIssuerResignCrlsRequest interface.
 */
export function instanceOfPkiIssuerResignCrlsRequest(value: object): value is PkiIssuerResignCrlsRequest {
    return true;
}

export function PkiIssuerResignCrlsRequestFromJSON(json: any): PkiIssuerResignCrlsRequest {
    return PkiIssuerResignCrlsRequestFromJSONTyped(json, false);
}

export function PkiIssuerResignCrlsRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): PkiIssuerResignCrlsRequest {
    if (json == null) {
        return json;
    }
    return {
        
        'crlNumber': json['crl_number'] == null ? undefined : json['crl_number'],
        'crls': json['crls'] == null ? undefined : json['crls'],
        'deltaCrlBaseNumber': json['delta_crl_base_number'] == null ? undefined : json['delta_crl_base_number'],
        'format': json['format'] == null ? undefined : json['format'],
        'nextUpdate': json['next_update'] == null ? undefined : json['next_update'],
    };
}

export function PkiIssuerResignCrlsRequestToJSON(json: any): PkiIssuerResignCrlsRequest {
    return PkiIssuerResignCrlsRequestToJSONTyped(json, false);
}

export function PkiIssuerResignCrlsRequestToJSONTyped(value?: PkiIssuerResignCrlsRequest | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
        'crl_number': value['crlNumber'],
        'crls': value['crls'],
        'delta_crl_base_number': value['deltaCrlBaseNumber'],
        'format': value['format'],
        'next_update': value['nextUpdate'],
    };
}

