/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface PkiIssuerSignRevocationListRequest
 */
export interface PkiIssuerSignRevocationListRequest {
    /**
     * The sequence number to be written within the CRL Number extension.
     * @type {number}
     * @memberof PkiIssuerSignRevocationListRequest
     */
    crlNumber?: number;
    /**
     * Using a zero or greater value specifies the base CRL revision number to encode within a Delta CRL indicator extension, otherwise the extension will not be added.
     * @type {number}
     * @memberof PkiIssuerSignRevocationListRequest
     */
    deltaCrlBaseNumber?: number;
    /**
     * A list of maps containing extensions with keys id (string), critical (bool), value (string)
     * @type {Array<object>}
     * @memberof PkiIssuerSignRevocationListRequest
     */
    extensions?: Array<object>;
    /**
     * The format of the combined CRL, can be "pem" or "der". If "der", the value will be base64 encoded. Defaults to "pem".
     * @type {string}
     * @memberof PkiIssuerSignRevocationListRequest
     */
    format?: string;
    /**
     * The amount of time the generated CRL should be valid; defaults to 72 hours.
     * @type {string}
     * @memberof PkiIssuerSignRevocationListRequest
     */
    nextUpdate?: string;
    /**
     * A list of maps containing the keys serial_number (string), revocation_time (string), and extensions (map with keys id (string), critical (bool), value (string))
     * @type {Array<object>}
     * @memberof PkiIssuerSignRevocationListRequest
     */
    revokedCerts?: Array<object>;
}

/**
 * Check if a given object implements the PkiIssuerSignRevocationListRequest interface.
 */
export function instanceOfPkiIssuerSignRevocationListRequest(value: object): value is PkiIssuerSignRevocationListRequest {
    return true;
}

export function PkiIssuerSignRevocationListRequestFromJSON(json: any): PkiIssuerSignRevocationListRequest {
    return PkiIssuerSignRevocationListRequestFromJSONTyped(json, false);
}

export function PkiIssuerSignRevocationListRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): PkiIssuerSignRevocationListRequest {
    if (json == null) {
        return json;
    }
    return {
        
        'crlNumber': json['crl_number'] == null ? undefined : json['crl_number'],
        'deltaCrlBaseNumber': json['delta_crl_base_number'] == null ? undefined : json['delta_crl_base_number'],
        'extensions': json['extensions'] == null ? undefined : json['extensions'],
        'format': json['format'] == null ? undefined : json['format'],
        'nextUpdate': json['next_update'] == null ? undefined : json['next_update'],
        'revokedCerts': json['revoked_certs'] == null ? undefined : json['revoked_certs'],
    };
}

export function PkiIssuerSignRevocationListRequestToJSON(json: any): PkiIssuerSignRevocationListRequest {
    return PkiIssuerSignRevocationListRequestToJSONTyped(json, false);
}

export function PkiIssuerSignRevocationListRequestToJSONTyped(value?: PkiIssuerSignRevocationListRequest | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
        'crl_number': value['crlNumber'],
        'delta_crl_base_number': value['deltaCrlBaseNumber'],
        'extensions': value['extensions'],
        'format': value['format'],
        'next_update': value['nextUpdate'],
        'revoked_certs': value['revokedCerts'],
    };
}

