/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface PkiWriteIssuerIssuerRefExternalPolicyIssuePolicyRequest
 */
export interface PkiWriteIssuerIssuerRefExternalPolicyIssuePolicyRequest {
    [key: string]: any | any;
    /**
     * Format for returned data. Can be "pem", "der", or "pem_bundle". If "pem_bundle", any private key and issuing cert will be appended to the certificate pem. If "der", the value will be base64 encoded. Defaults to "pem".
     * @type {string}
     * @memberof PkiWriteIssuerIssuerRefExternalPolicyIssuePolicyRequest
     */
    format?: PkiWriteIssuerIssuerRefExternalPolicyIssuePolicyRequestFormatEnum;
    /**
     * The number of bits to use. Allowed values are 0 (universal default); with rsa key_type: 2048 (default), 3072, or 4096; with ec key_type: 224, 256 (default), 384, or 521; ignored with ed25519.
     * @type {number}
     * @memberof PkiWriteIssuerIssuerRefExternalPolicyIssuePolicyRequest
     */
    keyBits?: number;
    /**
     * The type of key to use; defaults to RSA. "rsa" "ec" and "ed25519" are the only valid values.
     * @type {string}
     * @memberof PkiWriteIssuerIssuerRefExternalPolicyIssuePolicyRequest
     */
    keyType?: PkiWriteIssuerIssuerRefExternalPolicyIssuePolicyRequestKeyTypeEnum;
    /**
     * Format for the returned private key. Generally the default will be controlled by the "format" parameter as either base64-encoded DER or PEM-encoded DER. However, this can be set to "pkcs8" to have the returned private key contain base64-encoded pkcs8 or PEM-encoded pkcs8 instead. Defaults to "der".
     * @type {string}
     * @memberof PkiWriteIssuerIssuerRefExternalPolicyIssuePolicyRequest
     */
    privateKeyFormat?: PkiWriteIssuerIssuerRefExternalPolicyIssuePolicyRequestPrivateKeyFormatEnum;
    /**
     * Whether or not to remove self-signed CA certificates in the output of the ca_chain field.
     * @type {boolean}
     * @memberof PkiWriteIssuerIssuerRefExternalPolicyIssuePolicyRequest
     */
    removeRootsFromChain?: boolean;
}

/**
* @export
* @enum {string}
*/
export enum PkiWriteIssuerIssuerRefExternalPolicyIssuePolicyRequestFormatEnum {
    PEM = 'pem',
    DER = 'der',
    PEM_BUNDLE = 'pem_bundle'
}
/**
* @export
* @enum {string}
*/
export enum PkiWriteIssuerIssuerRefExternalPolicyIssuePolicyRequestKeyTypeEnum {
    RSA = 'rsa',
    EC = 'ec',
    ED25519 = 'ed25519'
}
/**
* @export
* @enum {string}
*/
export enum PkiWriteIssuerIssuerRefExternalPolicyIssuePolicyRequestPrivateKeyFormatEnum {
    DER = 'der',
    PEM = 'pem',
    PKCS8 = 'pkcs8'
}


/**
 * Check if a given object implements the PkiWriteIssuerIssuerRefExternalPolicyIssuePolicyRequest interface.
 */
export function instanceOfPkiWriteIssuerIssuerRefExternalPolicyIssuePolicyRequest(value: object): value is PkiWriteIssuerIssuerRefExternalPolicyIssuePolicyRequest {
    return true;
}

export function PkiWriteIssuerIssuerRefExternalPolicyIssuePolicyRequestFromJSON(json: any): PkiWriteIssuerIssuerRefExternalPolicyIssuePolicyRequest {
    return PkiWriteIssuerIssuerRefExternalPolicyIssuePolicyRequestFromJSONTyped(json, false);
}

export function PkiWriteIssuerIssuerRefExternalPolicyIssuePolicyRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): PkiWriteIssuerIssuerRefExternalPolicyIssuePolicyRequest {
    if (json == null) {
        return json;
    }
    return {
        
            ...json,
        'format': json['format'] == null ? undefined : json['format'],
        'keyBits': json['key_bits'] == null ? undefined : json['key_bits'],
        'keyType': json['key_type'] == null ? undefined : json['key_type'],
        'privateKeyFormat': json['private_key_format'] == null ? undefined : json['private_key_format'],
        'removeRootsFromChain': json['remove_roots_from_chain'] == null ? undefined : json['remove_roots_from_chain'],
    };
}

export function PkiWriteIssuerIssuerRefExternalPolicyIssuePolicyRequestToJSON(json: any): PkiWriteIssuerIssuerRefExternalPolicyIssuePolicyRequest {
    return PkiWriteIssuerIssuerRefExternalPolicyIssuePolicyRequestToJSONTyped(json, false);
}

export function PkiWriteIssuerIssuerRefExternalPolicyIssuePolicyRequestToJSONTyped(value?: PkiWriteIssuerIssuerRefExternalPolicyIssuePolicyRequest | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
            ...value,
        'format': value['format'],
        'key_bits': value['keyBits'],
        'key_type': value['keyType'],
        'private_key_format': value['privateKeyFormat'],
        'remove_roots_from_chain': value['removeRootsFromChain'],
    };
}

