/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface RateLimitQuotasConfigureRequest
 */
export interface RateLimitQuotasConfigureRequest {
    /**
     * Specifies the list of exempt global paths from all rate limit quotas. If empty no global paths will be exempt.
     * @type {Array<string>}
     * @memberof RateLimitQuotasConfigureRequest
     */
    absoluteRateLimitExemptPaths?: Array<string>;
    /**
     * If set, starts audit logging of requests that get rejected due to rate limit quota rule violations.
     * @type {boolean}
     * @memberof RateLimitQuotasConfigureRequest
     */
    enableRateLimitAuditLogging?: boolean;
    /**
     * If set, additional rate limit quota HTTP headers will be added to responses.
     * @type {boolean}
     * @memberof RateLimitQuotasConfigureRequest
     */
    enableRateLimitResponseHeaders?: boolean;
    /**
     * Specifies the list of exempt paths from all rate limit quotas. If empty no paths will be exempt.
     * @type {Array<string>}
     * @memberof RateLimitQuotasConfigureRequest
     */
    rateLimitExemptPaths?: Array<string>;
}

/**
 * Check if a given object implements the RateLimitQuotasConfigureRequest interface.
 */
export function instanceOfRateLimitQuotasConfigureRequest(value: object): value is RateLimitQuotasConfigureRequest {
    return true;
}

export function RateLimitQuotasConfigureRequestFromJSON(json: any): RateLimitQuotasConfigureRequest {
    return RateLimitQuotasConfigureRequestFromJSONTyped(json, false);
}

export function RateLimitQuotasConfigureRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): RateLimitQuotasConfigureRequest {
    if (json == null) {
        return json;
    }
    return {
        
        'absoluteRateLimitExemptPaths': json['absolute_rate_limit_exempt_paths'] == null ? undefined : json['absolute_rate_limit_exempt_paths'],
        'enableRateLimitAuditLogging': json['enable_rate_limit_audit_logging'] == null ? undefined : json['enable_rate_limit_audit_logging'],
        'enableRateLimitResponseHeaders': json['enable_rate_limit_response_headers'] == null ? undefined : json['enable_rate_limit_response_headers'],
        'rateLimitExemptPaths': json['rate_limit_exempt_paths'] == null ? undefined : json['rate_limit_exempt_paths'],
    };
}

export function RateLimitQuotasConfigureRequestToJSON(json: any): RateLimitQuotasConfigureRequest {
    return RateLimitQuotasConfigureRequestToJSONTyped(json, false);
}

export function RateLimitQuotasConfigureRequestToJSONTyped(value?: RateLimitQuotasConfigureRequest | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
        'absolute_rate_limit_exempt_paths': value['absoluteRateLimitExemptPaths'],
        'enable_rate_limit_audit_logging': value['enableRateLimitAuditLogging'],
        'enable_rate_limit_response_headers': value['enableRateLimitResponseHeaders'],
        'rate_limit_exempt_paths': value['rateLimitExemptPaths'],
    };
}

