/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface SystemPatchSyncDestinationsAzureKvNameRequest
 */
export interface SystemPatchSyncDestinationsAzureKvNameRequest {
    /**
     * Sets which IPv4 addresses Vault is allowed to connect to for syncing secrets.
     * @type {Array<string>}
     * @memberof SystemPatchSyncDestinationsAzureKvNameRequest
     */
    allowedIpv4Addresses?: Array<string>;
    /**
     * Sets which IPv6 addresses Vault is allowed to connect to for syncing secrets.
     * @type {Array<string>}
     * @memberof SystemPatchSyncDestinationsAzureKvNameRequest
     */
    allowedIpv6Addresses?: Array<string>;
    /**
     * Sets which port numbers Vault is allowed to connect through for syncing secrets.
     * @type {Array<string>}
     * @memberof SystemPatchSyncDestinationsAzureKvNameRequest
     */
    allowedPorts?: Array<string>;
    /**
     * OAuth2 client id of an Azure app registration with access to the key vault.
     * @type {string}
     * @memberof SystemPatchSyncDestinationsAzureKvNameRequest
     */
    clientId?: string;
    /**
     * OAuth2 client secret of an Azure app registration with access to the key vault.
     * @type {string}
     * @memberof SystemPatchSyncDestinationsAzureKvNameRequest
     */
    clientSecret?: string;
    /**
     * Azure environment name. If not provided, AzurePublicCloud is used.
     * @type {string}
     * @memberof SystemPatchSyncDestinationsAzureKvNameRequest
     */
    cloud?: string;
    /**
     * Custom tags to set on the secret managed at the destination. Custom tags are merged with system tags.
     * @type {object}
     * @memberof SystemPatchSyncDestinationsAzureKvNameRequest
     */
    customTags?: object;
    /**
     * Allows all IP addresses and ports to be connected to for syncing secrets.
     * @type {boolean}
     * @memberof SystemPatchSyncDestinationsAzureKvNameRequest
     */
    disableStrictNetworking?: boolean;
    /**
     * Determines what level of information is synced as a distinct resource at the destination. Supports `secret-path` and `secret-key`.
     * @type {string}
     * @memberof SystemPatchSyncDestinationsAzureKvNameRequest
     */
    granularity?: string;
    /**
     * URI of the Azure Key Vault to access.
     * @type {string}
     * @memberof SystemPatchSyncDestinationsAzureKvNameRequest
     */
    keyVaultUri?: string;
    /**
     * Asynchronously unsyncs all associated secrets with the destination then deletes the destination config.
     * @type {boolean}
     * @memberof SystemPatchSyncDestinationsAzureKvNameRequest
     */
    purge?: boolean;
    /**
     * Template describing how to generate external secret names. Supports a subset of the Go Template syntax.
     * @type {string}
     * @memberof SystemPatchSyncDestinationsAzureKvNameRequest
     */
    secretNameTemplate?: string;
    /**
     * List of custom tags to remove for patch requests. This field is ignored on create and update requests.
     * @type {Array<string>}
     * @memberof SystemPatchSyncDestinationsAzureKvNameRequest
     */
    tagsToRemove?: Array<string>;
    /**
     * Tenant id for the Azure Active Directory.
     * @type {string}
     * @memberof SystemPatchSyncDestinationsAzureKvNameRequest
     */
    tenantId?: string;
}

/**
 * Check if a given object implements the SystemPatchSyncDestinationsAzureKvNameRequest interface.
 */
export function instanceOfSystemPatchSyncDestinationsAzureKvNameRequest(value: object): value is SystemPatchSyncDestinationsAzureKvNameRequest {
    return true;
}

export function SystemPatchSyncDestinationsAzureKvNameRequestFromJSON(json: any): SystemPatchSyncDestinationsAzureKvNameRequest {
    return SystemPatchSyncDestinationsAzureKvNameRequestFromJSONTyped(json, false);
}

export function SystemPatchSyncDestinationsAzureKvNameRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): SystemPatchSyncDestinationsAzureKvNameRequest {
    if (json == null) {
        return json;
    }
    return {
        
        'allowedIpv4Addresses': json['allowed_ipv4_addresses'] == null ? undefined : json['allowed_ipv4_addresses'],
        'allowedIpv6Addresses': json['allowed_ipv6_addresses'] == null ? undefined : json['allowed_ipv6_addresses'],
        'allowedPorts': json['allowed_ports'] == null ? undefined : json['allowed_ports'],
        'clientId': json['client_id'] == null ? undefined : json['client_id'],
        'clientSecret': json['client_secret'] == null ? undefined : json['client_secret'],
        'cloud': json['cloud'] == null ? undefined : json['cloud'],
        'customTags': json['custom_tags'] == null ? undefined : json['custom_tags'],
        'disableStrictNetworking': json['disable_strict_networking'] == null ? undefined : json['disable_strict_networking'],
        'granularity': json['granularity'] == null ? undefined : json['granularity'],
        'keyVaultUri': json['key_vault_uri'] == null ? undefined : json['key_vault_uri'],
        'purge': json['purge'] == null ? undefined : json['purge'],
        'secretNameTemplate': json['secret_name_template'] == null ? undefined : json['secret_name_template'],
        'tagsToRemove': json['tags_to_remove'] == null ? undefined : json['tags_to_remove'],
        'tenantId': json['tenant_id'] == null ? undefined : json['tenant_id'],
    };
}

export function SystemPatchSyncDestinationsAzureKvNameRequestToJSON(json: any): SystemPatchSyncDestinationsAzureKvNameRequest {
    return SystemPatchSyncDestinationsAzureKvNameRequestToJSONTyped(json, false);
}

export function SystemPatchSyncDestinationsAzureKvNameRequestToJSONTyped(value?: SystemPatchSyncDestinationsAzureKvNameRequest | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
        'allowed_ipv4_addresses': value['allowedIpv4Addresses'],
        'allowed_ipv6_addresses': value['allowedIpv6Addresses'],
        'allowed_ports': value['allowedPorts'],
        'client_id': value['clientId'],
        'client_secret': value['clientSecret'],
        'cloud': value['cloud'],
        'custom_tags': value['customTags'],
        'disable_strict_networking': value['disableStrictNetworking'],
        'granularity': value['granularity'],
        'key_vault_uri': value['keyVaultUri'],
        'purge': value['purge'],
        'secret_name_template': value['secretNameTemplate'],
        'tags_to_remove': value['tagsToRemove'],
        'tenant_id': value['tenantId'],
    };
}

