/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface SystemPatchSyncDestinationsVercelProjectNameRequest
 */
export interface SystemPatchSyncDestinationsVercelProjectNameRequest {
    /**
     * Vercel API access token with the permissions to manage environment variables.
     * @type {string}
     * @memberof SystemPatchSyncDestinationsVercelProjectNameRequest
     */
    accessToken?: string;
    /**
     * Sets which IPv4 addresses Vault is allowed to connect to for syncing secrets.
     * @type {Array<string>}
     * @memberof SystemPatchSyncDestinationsVercelProjectNameRequest
     */
    allowedIpv4Addresses?: Array<string>;
    /**
     * Sets which IPv6 addresses Vault is allowed to connect to for syncing secrets.
     * @type {Array<string>}
     * @memberof SystemPatchSyncDestinationsVercelProjectNameRequest
     */
    allowedIpv6Addresses?: Array<string>;
    /**
     * Sets which port numbers Vault is allowed to connect through for syncing secrets.
     * @type {Array<string>}
     * @memberof SystemPatchSyncDestinationsVercelProjectNameRequest
     */
    allowedPorts?: Array<string>;
    /**
     * Deployment environments where the environment variables are available. Accepts 'development', 'preview' & 'production'.
     * @type {Array<string>}
     * @memberof SystemPatchSyncDestinationsVercelProjectNameRequest
     */
    deploymentEnvironments?: Array<string>;
    /**
     * Allows all IP addresses and ports to be connected to for syncing secrets.
     * @type {boolean}
     * @memberof SystemPatchSyncDestinationsVercelProjectNameRequest
     */
    disableStrictNetworking?: boolean;
    /**
     * Determines what level of information is synced as a distinct resource at the destination. Supports `secret-path` and `secret-key`.
     * @type {string}
     * @memberof SystemPatchSyncDestinationsVercelProjectNameRequest
     */
    granularity?: string;
    /**
     * Project ID where to manage environment variables.
     * @type {string}
     * @memberof SystemPatchSyncDestinationsVercelProjectNameRequest
     */
    projectId?: string;
    /**
     * Asynchronously unsyncs all associated secrets with the destination then deletes the destination config.
     * @type {boolean}
     * @memberof SystemPatchSyncDestinationsVercelProjectNameRequest
     */
    purge?: boolean;
    /**
     * Template describing how to generate external secret names. Supports a subset of the Go Template syntax.
     * @type {string}
     * @memberof SystemPatchSyncDestinationsVercelProjectNameRequest
     */
    secretNameTemplate?: string;
    /**
     * Team ID the project belongs to. Optional.
     * @type {string}
     * @memberof SystemPatchSyncDestinationsVercelProjectNameRequest
     */
    teamId?: string;
}

/**
 * Check if a given object implements the SystemPatchSyncDestinationsVercelProjectNameRequest interface.
 */
export function instanceOfSystemPatchSyncDestinationsVercelProjectNameRequest(value: object): value is SystemPatchSyncDestinationsVercelProjectNameRequest {
    return true;
}

export function SystemPatchSyncDestinationsVercelProjectNameRequestFromJSON(json: any): SystemPatchSyncDestinationsVercelProjectNameRequest {
    return SystemPatchSyncDestinationsVercelProjectNameRequestFromJSONTyped(json, false);
}

export function SystemPatchSyncDestinationsVercelProjectNameRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): SystemPatchSyncDestinationsVercelProjectNameRequest {
    if (json == null) {
        return json;
    }
    return {
        
        'accessToken': json['access_token'] == null ? undefined : json['access_token'],
        'allowedIpv4Addresses': json['allowed_ipv4_addresses'] == null ? undefined : json['allowed_ipv4_addresses'],
        'allowedIpv6Addresses': json['allowed_ipv6_addresses'] == null ? undefined : json['allowed_ipv6_addresses'],
        'allowedPorts': json['allowed_ports'] == null ? undefined : json['allowed_ports'],
        'deploymentEnvironments': json['deployment_environments'] == null ? undefined : json['deployment_environments'],
        'disableStrictNetworking': json['disable_strict_networking'] == null ? undefined : json['disable_strict_networking'],
        'granularity': json['granularity'] == null ? undefined : json['granularity'],
        'projectId': json['project_id'] == null ? undefined : json['project_id'],
        'purge': json['purge'] == null ? undefined : json['purge'],
        'secretNameTemplate': json['secret_name_template'] == null ? undefined : json['secret_name_template'],
        'teamId': json['team_id'] == null ? undefined : json['team_id'],
    };
}

export function SystemPatchSyncDestinationsVercelProjectNameRequestToJSON(json: any): SystemPatchSyncDestinationsVercelProjectNameRequest {
    return SystemPatchSyncDestinationsVercelProjectNameRequestToJSONTyped(json, false);
}

export function SystemPatchSyncDestinationsVercelProjectNameRequestToJSONTyped(value?: SystemPatchSyncDestinationsVercelProjectNameRequest | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
        'access_token': value['accessToken'],
        'allowed_ipv4_addresses': value['allowedIpv4Addresses'],
        'allowed_ipv6_addresses': value['allowedIpv6Addresses'],
        'allowed_ports': value['allowedPorts'],
        'deployment_environments': value['deploymentEnvironments'],
        'disable_strict_networking': value['disableStrictNetworking'],
        'granularity': value['granularity'],
        'project_id': value['projectId'],
        'purge': value['purge'],
        'secret_name_template': value['secretNameTemplate'],
        'team_id': value['teamId'],
    };
}

