/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface SystemWriteStorageRaftSnapshotAutoConfigNameRequest
 */
export interface SystemWriteStorageRaftSnapshotAutoConfigNameRequest {
    /**
     * AWS access key ID
     * @type {string}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    awsAccessKeyId?: string;
    /**
     * AWS bucket
     * @type {string}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    awsS3Bucket?: string;
    /**
     * Disable TLS for the AWS endpoint, intended only for testing
     * @type {boolean}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    awsS3DisableTls?: boolean;
    /**
     * Use KMS to encrypt bucket contents
     * @type {boolean}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    awsS3EnableKms?: boolean;
    /**
     * AWS endpoint, typically only set when using a non-AWS S3 instance like Minio
     * @type {string}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    awsS3Endpoint?: string;
    /**
     * Use the endpoint/bucket URL style instead of bucket.endpoint
     * @type {boolean}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    awsS3ForcePathStyle?: boolean;
    /**
     * Use named KMS key
     * @type {string}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    awsS3KmsKey?: string;
    /**
     * AWS region
     * @type {string}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    awsS3Region?: string;
    /**
     * Use AES256 to encrypt bucket contents
     * @type {boolean}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    awsS3ServerSideEncryption?: boolean;
    /**
     * AWS secret access key
     * @type {string}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    awsSecretAccessKey?: string;
    /**
     * AWS session token
     * @type {string}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    awsSessionToken?: string;
    /**
     * Azure account key
     * @type {string}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    azureAccountKey?: string;
    /**
     * Azure account name
     * @type {string}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    azureAccountName?: string;
    /**
     * Azure auth mode: shared, managed, or application
     * @type {string}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    azureAuthMode?: string;
    /**
     * Azure blob environment
     * @type {string}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    azureBlobEnvironment?: string;
    /**
     * Azure client id
     * @type {string}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    azureClientId?: string;
    /**
     * Azure container name
     * @type {string}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    azureContainerName?: string;
    /**
     * Azure blob storage endpoint
     * @type {string}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    azureEndpoint?: string;
    /**
     * file/object prefix prepended to snapshot ID
     * @type {string}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    filePrefix?: string;
    /**
     * Disable TLS, normally only for testing
     * @type {boolean}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    googleDisableTls?: boolean;
    /**
     * GCS endpoint
     * @type {string}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    googleEndpoint?: string;
    /**
     * GCS bucket
     * @type {string}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    googleGcsBucket?: string;
    /**
     * Service account key in JSON format
     * @type {string}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    googleServiceAccountKey?: string;
    /**
     * snapshot schedule
     * @type {string}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    interval?: string;
    /**
     * max space on disk to use for snapshots
     * @type {number}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    localMaxSpace?: number;
    /**
     * directory (local) or bucket prefix (cloud) for snapshot
     * @type {string}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    pathPrefix?: string;
    /**
     * how many snapshots to keep
     * @type {number}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    retain?: number;
    /**
     * type of storage to use for the snapshots
     * @type {string}
     * @memberof SystemWriteStorageRaftSnapshotAutoConfigNameRequest
     */
    storageType?: SystemWriteStorageRaftSnapshotAutoConfigNameRequestStorageTypeEnum;
}

/**
* @export
* @enum {string}
*/
export enum SystemWriteStorageRaftSnapshotAutoConfigNameRequestStorageTypeEnum {
    LOCAL = 'local',
    AZURE_BLOB = 'azure-blob',
    AWS_S3 = 'aws-s3',
    GOOGLE_GCS = 'google-gcs'
}


/**
 * Check if a given object implements the SystemWriteStorageRaftSnapshotAutoConfigNameRequest interface.
 */
export function instanceOfSystemWriteStorageRaftSnapshotAutoConfigNameRequest(value: object): value is SystemWriteStorageRaftSnapshotAutoConfigNameRequest {
    return true;
}

export function SystemWriteStorageRaftSnapshotAutoConfigNameRequestFromJSON(json: any): SystemWriteStorageRaftSnapshotAutoConfigNameRequest {
    return SystemWriteStorageRaftSnapshotAutoConfigNameRequestFromJSONTyped(json, false);
}

export function SystemWriteStorageRaftSnapshotAutoConfigNameRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): SystemWriteStorageRaftSnapshotAutoConfigNameRequest {
    if (json == null) {
        return json;
    }
    return {
        
        'awsAccessKeyId': json['aws_access_key_id'] == null ? undefined : json['aws_access_key_id'],
        'awsS3Bucket': json['aws_s3_bucket'] == null ? undefined : json['aws_s3_bucket'],
        'awsS3DisableTls': json['aws_s3_disable_tls'] == null ? undefined : json['aws_s3_disable_tls'],
        'awsS3EnableKms': json['aws_s3_enable_kms'] == null ? undefined : json['aws_s3_enable_kms'],
        'awsS3Endpoint': json['aws_s3_endpoint'] == null ? undefined : json['aws_s3_endpoint'],
        'awsS3ForcePathStyle': json['aws_s3_force_path_style'] == null ? undefined : json['aws_s3_force_path_style'],
        'awsS3KmsKey': json['aws_s3_kms_key'] == null ? undefined : json['aws_s3_kms_key'],
        'awsS3Region': json['aws_s3_region'] == null ? undefined : json['aws_s3_region'],
        'awsS3ServerSideEncryption': json['aws_s3_server_side_encryption'] == null ? undefined : json['aws_s3_server_side_encryption'],
        'awsSecretAccessKey': json['aws_secret_access_key'] == null ? undefined : json['aws_secret_access_key'],
        'awsSessionToken': json['aws_session_token'] == null ? undefined : json['aws_session_token'],
        'azureAccountKey': json['azure_account_key'] == null ? undefined : json['azure_account_key'],
        'azureAccountName': json['azure_account_name'] == null ? undefined : json['azure_account_name'],
        'azureAuthMode': json['azure_auth_mode'] == null ? undefined : json['azure_auth_mode'],
        'azureBlobEnvironment': json['azure_blob_environment'] == null ? undefined : json['azure_blob_environment'],
        'azureClientId': json['azure_client_id'] == null ? undefined : json['azure_client_id'],
        'azureContainerName': json['azure_container_name'] == null ? undefined : json['azure_container_name'],
        'azureEndpoint': json['azure_endpoint'] == null ? undefined : json['azure_endpoint'],
        'filePrefix': json['file_prefix'] == null ? undefined : json['file_prefix'],
        'googleDisableTls': json['google_disable_tls'] == null ? undefined : json['google_disable_tls'],
        'googleEndpoint': json['google_endpoint'] == null ? undefined : json['google_endpoint'],
        'googleGcsBucket': json['google_gcs_bucket'] == null ? undefined : json['google_gcs_bucket'],
        'googleServiceAccountKey': json['google_service_account_key'] == null ? undefined : json['google_service_account_key'],
        'interval': json['interval'] == null ? undefined : json['interval'],
        'localMaxSpace': json['local_max_space'] == null ? undefined : json['local_max_space'],
        'pathPrefix': json['path_prefix'] == null ? undefined : json['path_prefix'],
        'retain': json['retain'] == null ? undefined : json['retain'],
        'storageType': json['storage_type'] == null ? undefined : json['storage_type'],
    };
}

export function SystemWriteStorageRaftSnapshotAutoConfigNameRequestToJSON(json: any): SystemWriteStorageRaftSnapshotAutoConfigNameRequest {
    return SystemWriteStorageRaftSnapshotAutoConfigNameRequestToJSONTyped(json, false);
}

export function SystemWriteStorageRaftSnapshotAutoConfigNameRequestToJSONTyped(value?: SystemWriteStorageRaftSnapshotAutoConfigNameRequest | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
        'aws_access_key_id': value['awsAccessKeyId'],
        'aws_s3_bucket': value['awsS3Bucket'],
        'aws_s3_disable_tls': value['awsS3DisableTls'],
        'aws_s3_enable_kms': value['awsS3EnableKms'],
        'aws_s3_endpoint': value['awsS3Endpoint'],
        'aws_s3_force_path_style': value['awsS3ForcePathStyle'],
        'aws_s3_kms_key': value['awsS3KmsKey'],
        'aws_s3_region': value['awsS3Region'],
        'aws_s3_server_side_encryption': value['awsS3ServerSideEncryption'],
        'aws_secret_access_key': value['awsSecretAccessKey'],
        'aws_session_token': value['awsSessionToken'],
        'azure_account_key': value['azureAccountKey'],
        'azure_account_name': value['azureAccountName'],
        'azure_auth_mode': value['azureAuthMode'],
        'azure_blob_environment': value['azureBlobEnvironment'],
        'azure_client_id': value['azureClientId'],
        'azure_container_name': value['azureContainerName'],
        'azure_endpoint': value['azureEndpoint'],
        'file_prefix': value['filePrefix'],
        'google_disable_tls': value['googleDisableTls'],
        'google_endpoint': value['googleEndpoint'],
        'google_gcs_bucket': value['googleGcsBucket'],
        'google_service_account_key': value['googleServiceAccountKey'],
        'interval': value['interval'],
        'local_max_space': value['localMaxSpace'],
        'path_prefix': value['pathPrefix'],
        'retain': value['retain'],
        'storage_type': value['storageType'],
    };
}

