/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface SystemWriteSyncDestinationsInMemNameRequest
 */
export interface SystemWriteSyncDestinationsInMemNameRequest {
    /**
     * Sets which IPv4 addresses Vault is allowed to connect to for syncing secrets.
     * @type {Array<string>}
     * @memberof SystemWriteSyncDestinationsInMemNameRequest
     */
    allowedIpv4Addresses?: Array<string>;
    /**
     * Sets which IPv6 addresses Vault is allowed to connect to for syncing secrets.
     * @type {Array<string>}
     * @memberof SystemWriteSyncDestinationsInMemNameRequest
     */
    allowedIpv6Addresses?: Array<string>;
    /**
     * Sets which port numbers Vault is allowed to connect through for syncing secrets.
     * @type {Array<string>}
     * @memberof SystemWriteSyncDestinationsInMemNameRequest
     */
    allowedPorts?: Array<string>;
    /**
     * Allows all IP addresses and ports to be connected to for syncing secrets.
     * @type {boolean}
     * @memberof SystemWriteSyncDestinationsInMemNameRequest
     */
    disableStrictNetworking?: boolean;
    /**
     * Determines what level of information is synced as a distinct resource at the destination. Supports `secret-path` and `secret-key`.
     * @type {string}
     * @memberof SystemWriteSyncDestinationsInMemNameRequest
     */
    granularity?: string;
    /**
     * Asynchronously unsyncs all associated secrets with the destination then deletes the destination config.
     * @type {boolean}
     * @memberof SystemWriteSyncDestinationsInMemNameRequest
     */
    purge?: boolean;
    /**
     * Template describing how to generate external secret names. Supports a subset of the Go Template syntax.
     * @type {string}
     * @memberof SystemWriteSyncDestinationsInMemNameRequest
     */
    secretNameTemplate?: string;
}

/**
 * Check if a given object implements the SystemWriteSyncDestinationsInMemNameRequest interface.
 */
export function instanceOfSystemWriteSyncDestinationsInMemNameRequest(value: object): value is SystemWriteSyncDestinationsInMemNameRequest {
    return true;
}

export function SystemWriteSyncDestinationsInMemNameRequestFromJSON(json: any): SystemWriteSyncDestinationsInMemNameRequest {
    return SystemWriteSyncDestinationsInMemNameRequestFromJSONTyped(json, false);
}

export function SystemWriteSyncDestinationsInMemNameRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): SystemWriteSyncDestinationsInMemNameRequest {
    if (json == null) {
        return json;
    }
    return {
        
        'allowedIpv4Addresses': json['allowed_ipv4_addresses'] == null ? undefined : json['allowed_ipv4_addresses'],
        'allowedIpv6Addresses': json['allowed_ipv6_addresses'] == null ? undefined : json['allowed_ipv6_addresses'],
        'allowedPorts': json['allowed_ports'] == null ? undefined : json['allowed_ports'],
        'disableStrictNetworking': json['disable_strict_networking'] == null ? undefined : json['disable_strict_networking'],
        'granularity': json['granularity'] == null ? undefined : json['granularity'],
        'purge': json['purge'] == null ? undefined : json['purge'],
        'secretNameTemplate': json['secret_name_template'] == null ? undefined : json['secret_name_template'],
    };
}

export function SystemWriteSyncDestinationsInMemNameRequestToJSON(json: any): SystemWriteSyncDestinationsInMemNameRequest {
    return SystemWriteSyncDestinationsInMemNameRequestToJSONTyped(json, false);
}

export function SystemWriteSyncDestinationsInMemNameRequestToJSONTyped(value?: SystemWriteSyncDestinationsInMemNameRequest | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
        'allowed_ipv4_addresses': value['allowedIpv4Addresses'],
        'allowed_ipv6_addresses': value['allowedIpv6Addresses'],
        'allowed_ports': value['allowedPorts'],
        'disable_strict_networking': value['disableStrictNetworking'],
        'granularity': value['granularity'],
        'purge': value['purge'],
        'secret_name_template': value['secretNameTemplate'],
    };
}

