/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface TokenCreateOrphanRequest
 */
export interface TokenCreateOrphanRequest {
    /**
     * Name to associate with this token
     * @type {string}
     * @memberof TokenCreateOrphanRequest
     */
    displayName?: string;
    /**
     * Name of the entity alias to associate with this token
     * @type {string}
     * @memberof TokenCreateOrphanRequest
     */
    entityAlias?: string;
    /**
     * Explicit Max TTL of this token
     * @type {string}
     * @memberof TokenCreateOrphanRequest
     */
    explicitMaxTtl?: string;
    /**
     * Value for the token
     * @type {string}
     * @memberof TokenCreateOrphanRequest
     */
    id?: string;
    /**
     * Use 'ttl' instead
     * @type {string}
     * @memberof TokenCreateOrphanRequest
     * @deprecated
     */
    lease?: string;
    /**
     * Arbitrary key=value metadata to associate with the token
     * @type {object}
     * @memberof TokenCreateOrphanRequest
     */
    meta?: object;
    /**
     * Do not include default policy for this token
     * @type {boolean}
     * @memberof TokenCreateOrphanRequest
     */
    noDefaultPolicy?: boolean;
    /**
     * Create the token with no parent
     * @type {boolean}
     * @memberof TokenCreateOrphanRequest
     */
    noParent?: boolean;
    /**
     * Max number of uses for this token
     * @type {number}
     * @memberof TokenCreateOrphanRequest
     */
    numUses?: number;
    /**
     * Renew period
     * @type {string}
     * @memberof TokenCreateOrphanRequest
     */
    period?: string;
    /**
     * List of policies for the token
     * @type {Array<string>}
     * @memberof TokenCreateOrphanRequest
     */
    policies?: Array<string>;
    /**
     * Allow token to be renewed past its initial TTL up to system/mount maximum TTL
     * @type {boolean}
     * @memberof TokenCreateOrphanRequest
     */
    renewable?: boolean;
    /**
     * Time to live for this token
     * @type {string}
     * @memberof TokenCreateOrphanRequest
     */
    ttl?: string;
    /**
     * Token type
     * @type {string}
     * @memberof TokenCreateOrphanRequest
     */
    type?: string;
}

/**
 * Check if a given object implements the TokenCreateOrphanRequest interface.
 */
export function instanceOfTokenCreateOrphanRequest(value: object): value is TokenCreateOrphanRequest {
    return true;
}

export function TokenCreateOrphanRequestFromJSON(json: any): TokenCreateOrphanRequest {
    return TokenCreateOrphanRequestFromJSONTyped(json, false);
}

export function TokenCreateOrphanRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): TokenCreateOrphanRequest {
    if (json == null) {
        return json;
    }
    return {
        
        'displayName': json['display_name'] == null ? undefined : json['display_name'],
        'entityAlias': json['entity_alias'] == null ? undefined : json['entity_alias'],
        'explicitMaxTtl': json['explicit_max_ttl'] == null ? undefined : json['explicit_max_ttl'],
        'id': json['id'] == null ? undefined : json['id'],
        'lease': json['lease'] == null ? undefined : json['lease'],
        'meta': json['meta'] == null ? undefined : json['meta'],
        'noDefaultPolicy': json['no_default_policy'] == null ? undefined : json['no_default_policy'],
        'noParent': json['no_parent'] == null ? undefined : json['no_parent'],
        'numUses': json['num_uses'] == null ? undefined : json['num_uses'],
        'period': json['period'] == null ? undefined : json['period'],
        'policies': json['policies'] == null ? undefined : json['policies'],
        'renewable': json['renewable'] == null ? undefined : json['renewable'],
        'ttl': json['ttl'] == null ? undefined : json['ttl'],
        'type': json['type'] == null ? undefined : json['type'],
    };
}

export function TokenCreateOrphanRequestToJSON(json: any): TokenCreateOrphanRequest {
    return TokenCreateOrphanRequestToJSONTyped(json, false);
}

export function TokenCreateOrphanRequestToJSONTyped(value?: TokenCreateOrphanRequest | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
        'display_name': value['displayName'],
        'entity_alias': value['entityAlias'],
        'explicit_max_ttl': value['explicitMaxTtl'],
        'id': value['id'],
        'lease': value['lease'],
        'meta': value['meta'],
        'no_default_policy': value['noDefaultPolicy'],
        'no_parent': value['noParent'],
        'num_uses': value['numUses'],
        'period': value['period'],
        'policies': value['policies'],
        'renewable': value['renewable'],
        'ttl': value['ttl'],
        'type': value['type'],
    };
}

