/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface TransitGenerateDataKeyRequest
 */
export interface TransitGenerateDataKeyRequest {
    /**
     * Number of bits for the key; currently 128, 256, and 512 bits are supported. Defaults to 256.
     * @type {number}
     * @memberof TransitGenerateDataKeyRequest
     */
    bits?: number;
    /**
     * Context for key derivation. Required for derived keys.
     * @type {string}
     * @memberof TransitGenerateDataKeyRequest
     */
    context?: string;
    /**
     * The version of the Vault key to use for encryption of the data key. Must be 0 (for latest) or a value greater than or equal to the min_encryption_version configured on the key.
     * @type {number}
     * @memberof TransitGenerateDataKeyRequest
     */
    keyVersion?: number;
    /**
     * Nonce for when convergent encryption v1 is used (only in Vault 0.6.1)
     * @type {string}
     * @memberof TransitGenerateDataKeyRequest
     */
    nonce?: string;
    /**
     * The padding scheme to use for decrypt. Currently only applies to RSA key types. Options are 'oaep' or 'pkcs1v15'. Defaults to 'oaep'
     * @type {string}
     * @memberof TransitGenerateDataKeyRequest
     */
    paddingScheme?: string;
}

/**
 * Check if a given object implements the TransitGenerateDataKeyRequest interface.
 */
export function instanceOfTransitGenerateDataKeyRequest(value: object): value is TransitGenerateDataKeyRequest {
    return true;
}

export function TransitGenerateDataKeyRequestFromJSON(json: any): TransitGenerateDataKeyRequest {
    return TransitGenerateDataKeyRequestFromJSONTyped(json, false);
}

export function TransitGenerateDataKeyRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): TransitGenerateDataKeyRequest {
    if (json == null) {
        return json;
    }
    return {
        
        'bits': json['bits'] == null ? undefined : json['bits'],
        'context': json['context'] == null ? undefined : json['context'],
        'keyVersion': json['key_version'] == null ? undefined : json['key_version'],
        'nonce': json['nonce'] == null ? undefined : json['nonce'],
        'paddingScheme': json['padding_scheme'] == null ? undefined : json['padding_scheme'],
    };
}

export function TransitGenerateDataKeyRequestToJSON(json: any): TransitGenerateDataKeyRequest {
    return TransitGenerateDataKeyRequestToJSONTyped(json, false);
}

export function TransitGenerateDataKeyRequestToJSONTyped(value?: TransitGenerateDataKeyRequest | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
        'bits': value['bits'],
        'context': value['context'],
        'key_version': value['keyVersion'],
        'nonce': value['nonce'],
        'padding_scheme': value['paddingScheme'],
    };
}

