/* tslint:disable */
/* eslint-disable */
/**
 * HashiCorp Vault API
 * HTTP API that gives you full access to Vault. All API routes are prefixed with `/v1/`.
 *
 * The version of the OpenAPI document: 1.20.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface TransitGenerateHmacRequest
 */
export interface TransitGenerateHmacRequest {
    /**
     * Algorithm to use (POST body parameter). Valid values are: * sha2-224 * sha2-256 * sha2-384 * sha2-512 * sha3-224 * sha3-256 * sha3-384 * sha3-512 Defaults to "sha2-256".
     * @type {string}
     * @memberof TransitGenerateHmacRequest
     */
    algorithm?: string;
    /**
     * Specifies a list of items to be processed in a single batch. When this parameter is set, if the parameter 'input' is also set, it will be ignored. Any batch output will preserve the order of the batch input.
     * @type {Array<object>}
     * @memberof TransitGenerateHmacRequest
     */
    batchInput?: Array<object>;
    /**
     * The base64-encoded input data
     * @type {string}
     * @memberof TransitGenerateHmacRequest
     */
    input?: string;
    /**
     * The version of the key to use for generating the HMAC. Must be 0 (for latest) or a value greater than or equal to the min_encryption_version configured on the key.
     * @type {number}
     * @memberof TransitGenerateHmacRequest
     */
    keyVersion?: number;
}

/**
 * Check if a given object implements the TransitGenerateHmacRequest interface.
 */
export function instanceOfTransitGenerateHmacRequest(value: object): value is TransitGenerateHmacRequest {
    return true;
}

export function TransitGenerateHmacRequestFromJSON(json: any): TransitGenerateHmacRequest {
    return TransitGenerateHmacRequestFromJSONTyped(json, false);
}

export function TransitGenerateHmacRequestFromJSONTyped(json: any, ignoreDiscriminator: boolean): TransitGenerateHmacRequest {
    if (json == null) {
        return json;
    }
    return {
        
        'algorithm': json['algorithm'] == null ? undefined : json['algorithm'],
        'batchInput': json['batch_input'] == null ? undefined : json['batch_input'],
        'input': json['input'] == null ? undefined : json['input'],
        'keyVersion': json['key_version'] == null ? undefined : json['key_version'],
    };
}

export function TransitGenerateHmacRequestToJSON(json: any): TransitGenerateHmacRequest {
    return TransitGenerateHmacRequestToJSONTyped(json, false);
}

export function TransitGenerateHmacRequestToJSONTyped(value?: TransitGenerateHmacRequest | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
        'algorithm': value['algorithm'],
        'batch_input': value['batchInput'],
        'input': value['input'],
        'key_version': value['keyVersion'],
    };
}

